/*** sysLib.h - system i/f header ***/

/*** Copyright(C) 2008 mimu ***/

/*** NOTE ***
 */

/*** HISTORY ***
 * 2007/08/xx mimu@emb
              First version for SH-4A
 */

#ifndef	INC_sysLib_H
#define	INC_sysLib_H

#ifndef	_ASMLANGUAGE

#include	"config.h"

//#include	"kernel.h"

#ifdef	__cplusplus
extern "C" {
#endif


int sysInit( void );

void sysDummyFunc();
void sysHalt( const char * msg );

/* interrupt mask */
int		sysIntLock( void );
void	sysIntUnlock( int );

void bspDelay100nSec( int count );

const char * sysOptionStringSerch( const char * pOpt, int *pLen, char startcode );

/* for interrupt */
typedef enum {
#ifndef	SUPPORT_CPU_TIMER_0
#error	/* system need timer0 */
#endif
	IntID_Timer0 = 0,

#ifdef	SUPPORT_CPU_TIMER_1
	IntID_Timer1,
#endif
#ifdef	SUPPORT_CPU_TIMER_2
	IntID_Timer2,
#endif

#ifdef	SUPPORT_SCI_A
	IntID_SciA_RX,
	IntID_SciA_TX,
#endif
	IntID_Num
} IntID;

int sysIntConnect( IntID id, void (*pFunc)(void *), void * arg );
int sysIntEnable( IntID id );
int sysIntDisable( IntID id );

//void * sysAlloc( unsigned long size, unsigned long aligne, int bDma );

//extern void cachePurge( void * p, unsigned long size);	/* this function defined in romInit.src */

/*** for NV-RAM ***/

#if 0
//int sysNvRamInit( void );
//
//int	sysNvRamMacGet( int ch, unsigned char * pMac );
//int sysNvRamMacSet( int ch, unsigned char * pMac );
//
//int sysNvRamNetGet( int ch, SysNetCfg * pNet );
//int sysNvRamNetSet( int ch, SysNetCfg * pNet );
//
//int sysNvRamExceptionGet( SysException * pSysException );
//
//int sysNvRamConsoleBpsGet( void );
//int sysNvRamConsoleBpsSet( int bps );
//
//int sysNvRamPasswordGet( unsigned char * password );
//int sysNvRamPasswordSet( unsigned char * password, int len );
//
//int sysNvRamLcdContrastGet( void );
//int sysNvRamLcdContrastSet( int contrast );
#endif

#if 0	/* move to sysNvRam.h */
int	sysNvRamMacGet( int ch, unsigned char * );
int sysNvRamMacSet( int ch, unsigned char * );
#endif

#ifdef	__cplusplus
}
#endif

#endif	/* _ASMLANGUAGE */
#endif	/* INC_sysLib_H */

/*** end of file : sysLib.h ***/
