/*** clkCtrl.h - TMS320F28035 Clock and PLL control ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/02/19 mimu
              First Version
 */

#include "config.h"

#ifndef	PCLKCR0_INIT
#define	PCLKCR0_INIT	0x0000
#endif

#ifndef	PCLKCR1_INIT
#define	PCLKCR1_INIT	0x0000
#endif

#ifndef	PCLKCR3_INIT
#define	PCLKCR3_INIT	0x2700
#endif

int clk_init( void );

#define	_CLK_ID_( _reg, _bit )	((_reg)<<8) | (_bit))
#define	_CLK_ID_2_REG_NO(_id)	(((_id)>>8)&0xf)
#define	_CLK_ID_2_BIT(_id)		((_id)&0xff)

#define	CLKID_ECAN_A	_CLK_ID(0,14)	/* ECAN-A clock								*/
#define	CLKID_SCI_A		_CLK_ID(0,10)	/* SCI-A clock								*/
#define	CLKID_SPI_B		_CLK_ID(0, 9)	/* SPI-B clock								*/
#define	CLKID_SPI_A		_CLK_ID(0, 8)	/* SPI-A clock								*/
#define	CLKID_I2C		_CLK_ID(0, 4)	/* I2C clock								*/
#define	CLKID_ADC		_CLK_ID(0, 3)	/* ADC clock								*/
#define	CLKID_TBCLK		_CLK_ID(0, 2)	/* ePWM Module Time Base Clock (TBCLK) Sync	*/
#define	CLKID_LIN_A		_CLK_ID(0, 1)	/* LIN-A clock								*/
#define	CLKID_HRPWM		_CLK_ID(0, 0)	/* HRPWM clock								*/

#define	CLKID_EQEP1		_CLK_ID(1,15)	/* eQEP1 clock								*/
#define	CLKID_ECAP1		_CLK_ID(1,14)	/* eCAP1 clock								*/
#define	CLKID_EPWM7		_CLK_ID(1, 6)	/* ePWM7 clock								*/
#define	CLKID_EPWM6		_CLK_ID(1, 5)	/* ePWM6 clock								*/
#define	CLKID_EPWM5		_CLK_ID(1, 4)	/* ePWM5 clock								*/
#define	CLKID_EPWM4		_CLK_ID(1, 3)	/* ePWM4 clock								*/
#define	CLKID_EPWM3		_CLK_ID(1, 2)	/* ePWM3 clock								*/
#define	CLKID_EPWM2		_CLK_ID(1, 1)	/* ePWM2 clock								*/
#define	CLKID_EPWM1		_CLK_ID(1, 0)	/* ePWM1 clock								*/

#define	CLKID_CLA		_CLK_ID(3,14)	/* CLA module clock							*/
#define	CLKID_GPIOIN	_CLK_ID(3,13)	/* GPIO Input Clock							*/
#define	CLKID_CPUTIMER2	_CLK_ID(3,10)	/* CPU Timer 2 Clock						*/
#define	CLKID_CPUTIMER1	_CLK_ID(3, 9)	/* CPU Timer 1 Clock						*/
#define	CLKID_CPUTIMER0	_CLK_ID(3, 0)	/* CPU Timer 0 Clock						*/
#define	CLKID_COMP3		_CLK_ID(3, 2)	/* Comparator3 clock						*/
#define	CLKID_COMP2		_CLK_ID(3, 1)	/* Comparator2 clock						*/
#define	CLKID_COMP1)	_CLK_ID(3, 0)	/* Comparator1 clock						*/

int clk_ctrl( int clkID, int bEnable );


#define	CLK_LSPCLK_1		0	/* Low speed clock = SYSCLKOUT/1  */
#define	CLK_LSPCLK_2		1	/* Low speed clock = SYSCLKOUT/2  */
#define	CLK_LSPCLK_4		2	/* Low speed clock = SYSCLKOUT/4  */
#define	CLK_LSPCLK_6		3	/* Low speed clock = SYSCLKOUT/6  */
#define	CLK_LSPCLK_8		4	/* Low speed clock = SYSCLKOUT/8  */
#define	CLK_LSPCLK_10		5	/* Low speed clock = SYSCLKOUT/10 */
#define	CLK_LSPCLK_12		6	/* Low speed clock = SYSCLKOUT/12 */
#define	CLK_LSPCLK_14		7	/* Low speed clock = SYSCLKOUT/14 */

int clk_lsp( int val );

#define	Device_cal	(void(*)(void))0x3d7c80

/*** end of file : clkCtrl.h ***/
