/*** gpioDrv.h - TMS320F28035(piccolo) GPIO driver ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/02/09 mimu
              First Version
 */

#ifndef	INC_gpioDrv_H
#define	INC_gpioDrv_H

#define	GPIO_MAX	44
#define	GPIO_NUM	45

int gpioInit( void );
int gpioConfig( int no, int mode );
#define	GPIO_MODE_GPIO			0x001
#define	GPIO_MODE_1				0x002
#define	GPIO_MODE_2				0x004
#define	GPIO_MODE_3				0x008

#define	GPIO_MODE_IN			0x010
#define	GPIO_MODE_OUT			0x020
#define	GPIO_MODE_PULLUP_DIS	0x040
#define	GPIO_MODE_PULLUP		0x080

#define	GPIO_MODE_QUALIFIER_0	0x100
#define	GPIO_MODE_QUALIFIER_1	0x200
#define	GPIO_MODE_QUALIFIER_2	0x400
#define	GPIO_MODE_QUALIFIER_3	0x800
#define	GPIO_MODE_QUALIFILER(_x)	(0x100<<(_x))&0x0f00))

int gpioControl( int no, int bHigh );
int gpioSet( int no );
int gpioClear( int no );
int gpioToggle( int no );
int gpioGet( int no );
int gpioCtrlRegSet( int reg, int value );

int gpioCtrlRegSet( int reg, int value );
#define	GPIO_CTRLREG_QUALPRD_0_7	0		/* GPIO 0-7 */
#define	GPIO_CTRLREG_QUALPRD_8_15	1		/* GPIO 8-15 */
#define	GPIO_CTRLREG_QUALPRD_16_23	2		/* GPIO 16-23 */
#define	GPIO_CTRLREG_QUALPRD_24_31	3		/* GPIO 24-31 */

#define	GPIO_CTRLREG_QUBLPRD_32_39	4		/* GPIO 32-39 */
#define	GPIO_CTRLREG_QUBLPRD_40_44	5		/* GPIO 32-44 */

#endif	/* INC_gpioDrv_H */

/*** end of file : gpioDrv.h ***/
