/*** main.c - TMS320F28035 main ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/02/07 mimu
              First Version
 */

/*** NOTE ***/

/*** INCLUDE ***/
#include "config.h"
#include "sysLib.h"
#include "tms320f28035/gpioDrv.h"
#include "tms320f28035/timerDrv.h"
#include "tms320f28035/sciDrv.h"
#include "tms320f28035/flashDrv.h"

//#include "DSP28x_Project.h"     // Device Headerfile and Examples Include File

/*** DEFINE ***/
extern void loader( void );

/*** FUNCTION ***/

/*** WORK ***/

/*******************************************************************************
 *
 */
void mainError( int lineNo, int code )
{

	for( ; ; ) {
		;
	}
}

/*******************************************************************************
 *
 */
void main(void)
{
	int result;

	/*
	 * system initialize
	 */
	result = sysInit();
	if( result ) {
		mainError( __LINE__, result );
	}

	/*
	 * GPIO driver initialize
	 */
	result = gpioInit();
	if( result ) {
		mainError( __LINE__, result );
	}

	/*
	 * Flash-Mem Driver initialize
	 */
	result = flashInit();
	if( result ) {
		mainError( __LINE__, result );
	}

	/* Configure GPIO output pin */
	result = gpioConfig( GPIO_NO_CPU_LED, (GPIO_MODE_GPIO | GPIO_MODE_OUT) );
	if( result ) {
		mainError( __LINE__, result );
	}

	gpioClear( GPIO_NO_CPU_LED );
	loader();
	gpioSet( GPIO_NO_CPU_LED );
#if 1
	{
		unsigned short * p;
		void (*pEntry)(void);

		p = (unsigned short *)0x3e8000;
		pEntry = (void(*)(void))0x3e8000;
		
		if( *p != 0xffff )
		{
			pEntry(); 
		}
	}
#endif
	{
		volatile int count;
		for( ; ; ) {
			for( count; count<0x100; count++ ) {
				;
			}
			gpioToggle( GPIO_NO_CPU_LED );
		}
	}
}


