L 1 "../src/bsp/lib/ringLib.c"
N/*** ringLib.c - Ring Buffer Manager ***/
N
N/*** Copyright(C) 1989-2011 Kazuya Mimura ***/
N/*** Copyrigth(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/16 mimu
N              Clean-up & remodify
N * 1989/07/xx mimu
N              First Version
N */
N
N/*** NOTE ***/
N
N/*** INCLUDE ***/
N#include "sysLib.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/bsp/sysLib.h" 1
N/*** sysLib.h - system i/f header ***/
N
N/*** Copyright(C) 2008 mimu ***/
N
N/*** NOTE ***
N */
N
N/*** HISTORY ***
N * 2007/08/xx mimu@emb
N              First version for SH-4A
N */
N
N#ifndef	INC_sysLib_H
N#define	INC_sysLib_H
N
N#ifndef	_ASMLANGUAGE
N
N#include	"config.h"
L 1 "D:\project\fpalette\ccs4\fpalette\ide_led\src\bsp\config.h" 1
N/*** config.h ***/
N
N
N#ifndef	INC_config_H
N#define	INC_config_H
N
N/******************************************************************************/
N/* NvRam Configuration                                                        */
N/******************************************************************************/
N#define	FLASH_PROGRAM_SEC_NO		0
N#define	FLASH_PROGRAM_SEC_NUM		6
N
N#define	FLASH_BOOTLOADER_SEC_NO		(FLASH_PROGRAM_SEC_NO + FLASH_PROGRAM_SEC_NUM)
N#define	FLASH_BOOTLOADER_SEC_NUM	2
N
N/******************************************************************************/
N/* Driver Configuration                                                       */
N/******************************************************************************/
N
N/*** CPU TIMER ***/
N#define	SUPPORT_CPU_TIMER_0		/* !! ATTATION !! system need timer0 */
N//#define	SUPPORT_CPU_TIMER_1
N//#define	SUPPORT_CPU_TIMER_2
N
N/*** SCI ***/
N#define	SUPPORT_SCI_A
N
N/*** Flash Mem. ***/
N//#define	SUPPORT_FLASH
N
N/******************************************************************************/
N/* GPIO map                                                                   */
N/******************************************************************************/
N#define	GPIO_NO_CPU_LED	39
N
N//#define	GPIO_NO_SCIRXDA	7
N#define	GPIO_NO_SCIRXDA	28
N
N//#define	GPIO_NO_SCITXDA	12
N#define	GPIO_NO_SCITXDA	29
N
N
N/*-----------------------------------------------------------------------------
N      Specify the PLL control register (PLLCR) and divide select (DIVSEL) value.
N-----------------------------------------------------------------------------*/
N
N//#define DSP28_DIVSEL   0 // Enable /4 for SYSCLKOUT
N//#define DSP28_DIVSEL   1 // Disable /4 for SYSCKOUT
N#define DSP28_DIVSEL   2 // Enable /2 for SYSCLKOUT
N//#define DSP28_DIVSEL   3 // Enable /1 for SYSCLKOUT
N
N
N#define DSP28_PLLCR   12    // Uncomment for 60 MHz devices [60 MHz = (10MHz * 12)/2]
N//#define DSP28_PLLCR   11
N//#define DSP28_PLLCR   10
N//#define DSP28_PLLCR    9
N//#define DSP28_PLLCR    8      // Uncomment for 40 MHz devices [40 MHz = (10MHz * 8)/2]
N//#define DSP28_PLLCR    7
N//#define DSP28_PLLCR    6
N//#define DSP28_PLLCR    5
N//#define DSP28_PLLCR    4
N//#define DSP28_PLLCR    3
N//#define DSP28_PLLCR    2
N//#define DSP28_PLLCR    1
N//#define DSP28_PLLCR    0  // PLL is bypassed in this mode
N//----------------------------------------------------------------------------
N
N/*-----------------------------------------------------------------------------
N      Specify the clock rate of the CPU (SYSCLKOUT) in nS.
N
N      Take into account the input clock frequency and the PLL multiplier
N      selected in step 1.
N
N      Use one of the values provided, or define your own.
N      The trailing L is required tells the compiler to treat
N      the number as a 64-bit value.
N
N      Only one statement should be uncommented.
N
N      Example:   60 MHz devices:
N                 CLKIN is a 10 MHz crystal or internal 10 MHz oscillator
N
N                 In step 1 the user specified PLLCR = 0xC for a
N                 60 MHz CPU clock (SYSCLKOUT = 60 MHz).
N
N                 In this case, the CPU_RATE will be 16.667L
N                 Uncomment the line: #define CPU_RATE 16.667L
N
N-----------------------------------------------------------------------------*/
N
N#define CPU_RATE   16.667L   // for a 60MHz CPU clock speed (SYSCLKOUT)
N//#define CPU_RATE   20.000L   // for a 50MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   25.000L   // for a 40MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   33.333L   // for a 30MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   41.667L   // for a 24MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   50.000L   // for a 20MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   66.667L   // for a 15MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE  100.000L   // for a 10MHz CPU clock speed  (SYSCLKOUT)
N
N#if 0
S//----------------------------------------------------------------------------
S
S// The following pointer to a function call calibrates the ADC and internal oscillators
S#define Device_cal (void   (*)(void))0x3D7C80
S
S//---------------------------------------------------------------------------
S// Include Example Header Files:
S//
S
S#include "DSP2803x_GlobalPrototypes.h"         // Prototypes for global functions within the
S                                               // .c files.
S#include "DSP2803x_EPwm_defines.h"             // Macros used for PWM examples.
S#include "DSP2803x_I2C_defines.h"              // Macros used for I2C examples.
S#include "DSP2803x_Cla_Defines.h"              // Macros used for CLA examples.
S
S
S#define   PARTNO_28030PAG   0xAA
S#define   PARTNO_28030PN    0xAB
S
S#define   PARTNO_28031PAG   0xAE
S#define   PARTNO_28031PN    0xAF
S
S#define   PARTNO_28032PAG   0xB2
S#define   PARTNO_28032PN    0xB3
S
S#define   PARTNO_28033PAG   0xB6
S#define   PARTNO_28033PN    0xB7
S
S#define   PARTNO_28034PAG   0xBA
S#define   PARTNO_28034PN    0xBB
S
S#define   PARTNO_28035PAG   0xBE
S#define   PARTNO_28035PN    0xBF
S
S// Include files not used with DSP/BIOS
S#ifndef DSP28_BIOS
S#include "DSP2803x_DefaultISR.h"
S#endif
N#endif
N
Nextern void DSP28x_usDelay(unsigned long Count);
N// DO NOT MODIFY THIS LINE.
N#define DELAY_US(A)  DSP28x_usDelay(((((long double) A * 1000.0L) / (long double)CPU_RATE) - 9.0L) / 5.0L)
N
N#endif	/* INC_config_H */
N
N/*** end of file : config.h ***/
L 19 "D:/project/fpalette/ccs4/fpalette/ide_led/src/bsp/sysLib.h" 2
N
N//#include	"kernel.h"
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
N
Nint sysInit( void );
N
Nvoid sysDummyFunc();
Nvoid sysHalt( const char * msg );
N
N/* interrupt mask */
Nint		sysIntLock( void );
Nvoid	sysIntUnlock( int );
N
Nvoid bspDelay100nSec( int count );
N
Nconst char * sysOptionStringSerch( const char * pOpt, int *pLen, char startcode );
N
N/* for interrupt */
Nint sysIntConnect( unsigned int vecNo, void (*pFunc)(unsigned int vecNo) );
Nint sysIntEnable( unsigned int vecNo );
Nint sysIntDisable( unsigned int vecNo );
N
N//void * sysAlloc( unsigned long size, unsigned long aligne, int bDma );
N
N//extern void cachePurge( void * p, unsigned long size);	/* this function defined in romInit.src */
N
N/*** for NV-RAM ***/
N
N#if 0
S//int sysNvRamInit( void );
S//
S//int	sysNvRamMacGet( int ch, unsigned char * pMac );
S//int sysNvRamMacSet( int ch, unsigned char * pMac );
S//
S//int sysNvRamNetGet( int ch, SysNetCfg * pNet );
S//int sysNvRamNetSet( int ch, SysNetCfg * pNet );
S//
S//int sysNvRamExceptionGet( SysException * pSysException );
S//
S//int sysNvRamConsoleBpsGet( void );
S//int sysNvRamConsoleBpsSet( int bps );
S//
S//int sysNvRamPasswordGet( unsigned char * password );
S//int sysNvRamPasswordSet( unsigned char * password, int len );
S//
S//int sysNvRamLcdContrastGet( void );
S//int sysNvRamLcdContrastSet( int contrast );
N#endif
N
N#if 0	/* move to sysNvRam.h */
Sint	sysNvRamMacGet( int ch, unsigned char * );
Sint sysNvRamMacSet( int ch, unsigned char * );
N#endif
N
N#ifdef	__cplusplus
S}
N#endif
N
N#endif	/* _ASMLANGUAGE */
N#endif	/* INC_sysLib_H */
N
N/*** end of file : sysLib.h ***/
L 17 "../src/bsp/lib/ringLib.c" 2
N#include "ringLib.h"
L 1 "..\src\bsp\lib\ringLib.h" 1
N/*** ringLib.c - Ring Buffer Manager ***/
N
N/*** Copyright(C) 1989-2011 Kazuya Mimura ***/
N/*** Copyrigth(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/16 mimu
N              Clean-up & remodify
N * 1989/07/xx mimu
N              First Version
N */
N
N#ifndef	INC_ringLib_H
N#define	INC_ringLib_H
N
Ntypedef	struct ring_t {
N	unsigned char * pDataTop;
N	int				size;
N
N	unsigned char * pGet;
N	unsigned char * pSetNext;
N	unsigned char * pDataBotom;
N} Ring;
N
Nint ringInit( Ring * pRing );
Nint ringSet( Ring * pRing, unsigned char * pData, int size );
Nint ringGet( Ring * pRing, unsigned char * pData, int size );
Nvoid ringFlush( Ring * pRing );
Nint ringSize( Ring * pRing );
Nunsigned char ringPeek( Ring * pRing );
N
N#endif	/* INC_ringLib_H */
N/*** end of file : ringLib.c ***/
L 18 "../src/bsp/lib/ringLib.c" 2
N
N/*** DEFINE ***/
N/*** FUNCTION ***/
N/*** WORK ***/
N
N/*******************************************************************************
N *
N */
Nint ringInit( Ring * pRing )
N{
N	int retVal;
N
N	retVal = -1;
N	if( pRing->pDataTop ) {
N		if( pRing->size >= 4 ) {
N			pRing->pDataBotom = pRing->pDataTop + pRing->size;
N			pRing->pGet = pRing->pDataTop;
N			pRing->pSetNext = pRing->pDataTop + 1;
N
N			retVal = 0;
N		}
N	}
N
N	return retVal;
N}
N
N/*******************************************************************************
N *
N */
Nint ringSet( Ring * pRing, unsigned char * pData, int size )
N{
N	int retVal;
N	int intLockVal;
N	int bNotFull;
N
N	retVal = 0;
N
N	for( bNotFull=1; (bNotFull) && (size > 0); ) {
N		intLockVal = sysIntLock();
N		if( pRing->pSetNext != pRing->pGet ) {
N			*pRing->pSetNext = *pData;
N			pRing->pSetNext ++;
N			if( pRing->pSetNext == pRing->pDataBotom ) {
N				pRing->pSetNext = pRing->pDataTop;
N			}
N			pData ++;
N			size --;
N			retVal ++;
N		} else {
N			bNotFull = 0;
N		}
N		sysIntUnlock( intLockVal );
N	}
N
N	return retVal;
N}
N
N/*******************************************************************************
N *
N */
Nint ringGet( Ring * pRing, unsigned char * pData, int size )
N{
N	int retVal;
N	unsigned char * pNext;
N	int intLockVal;
N	int bNotEmpty;
N
N	retVal = 0;
N
N	intLockVal = sysIntLock();
N
N	pNext = pRing->pGet + 1;
N	if( pNext == pRing->pDataBotom ) {
N		pNext = pRing->pDataTop;
N	}
N
N	for( bNotEmpty=1; (bNotEmpty) && (size > 0); ) {
N		if( pNext != pRing->pSetNext ) {
N			*pData = *pNext;
N			pData ++;
N			size --;
N			pRing->pGet = pNext;
N			retVal ++;
N
N			pNext ++;
N			if( pNext == pRing->pDataBotom ) {
N				pNext = pRing->pDataTop;
N			}
N		} else {
N			bNotEmpty = 0;
N		}
N	}
N	sysIntUnlock(intLockVal);
N
N	return retVal;
N}
N
N/*******************************************************************************
N *
N */
Nunsigned char ringPeek( Ring * pRing )
N{
N	unsigned char retVal;
N	unsigned char * pNext;
N	int intLockVal;
N
N	retVal = 0;
N
N	intLockVal = sysIntLock();
N
N	pNext = pRing->pGet + 1;
N	if( pNext == pRing->pDataBotom ) {
N		pNext = pRing->pDataTop;
N	}
N
N	if( pNext != pRing->pSetNext ) {
N		retVal = *pNext;
N	} else {
N	}
N
N	sysIntUnlock(intLockVal);
N
N	return retVal;
N
N}
N
N/*******************************************************************************
N *
N */
Nvoid ringFlush( Ring * pRing )
N{
N	int intLockVal;
N
N	intLockVal = sysIntLock();
N
N	pRing->pGet = pRing->pDataTop;
N	pRing->pSetNext = pRing->pDataTop+1;
N
N	sysIntUnlock(intLockVal);
N}
N
N/*******************************************************************************
N *
N */
Nint ringSize( Ring * pRing )
N{
N	int intLockVal;
N	int size;
N	unsigned long get, setNext;
N
N	intLockVal = sysIntLock();
N	get = (unsigned long)pRing->pGet;
N	setNext = (unsigned long)pRing->pSetNext;
N	sysIntUnlock(intLockVal);
N
N	if( get == setNext ) {
N		size = pRing->size;
N	} else if( get < setNext ) {
N		size = setNext - get - 1;
N	} else {
N		size = pRing->size - (get - setNext);
N	}
N
N	return size;
N}
N
N/*** end of file : ringLib.c ***/
