L 1 "../src/bsp/tms320f28035/pwmDrv.c"
N/*** pwmDrv.c - TMS320F28035 PWM Driver ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/03/04 mimu
N              First Version
N */
N
N/*** NOTE ***/
N
N/*** INCLUDE ***/
N#include "config.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/bsp/config.h" 1
N/*** config.h ***/
N
N
N#ifndef	INC_config_H
N#define	INC_config_H
N
N/******************************************************************************/
N/* NvRam Configuration                                                        */
N/******************************************************************************/
N#define	FLASH_PROGRAM_SEC_NO		0
N#define	FLASH_PROGRAM_SEC_NUM		6
N
N#define	FLASH_BOOTLOADER_SEC_NO		(FLASH_PROGRAM_SEC_NO + FLASH_PROGRAM_SEC_NUM)
N#define	FLASH_BOOTLOADER_SEC_NUM	2
N
N/******************************************************************************/
N/* Driver Configuration                                                       */
N/******************************************************************************/
N
N/*** CPU TIMER ***/
N#define	SUPPORT_CPU_TIMER_0		/* !! ATTATION !! system need timer0 */
N//#define	SUPPORT_CPU_TIMER_1
N//#define	SUPPORT_CPU_TIMER_2
N
N/*** SCI ***/
N#define	SUPPORT_SCI_A
N
N/*** Flash Mem. ***/
N//#define	SUPPORT_FLASH
N
N/******************************************************************************/
N/* GPIO map                                                                   */
N/******************************************************************************/
N#define	GPIO_NO_CPU_LED	39
N
N//#define	GPIO_NO_SCIRXDA	7
N#define	GPIO_NO_SCIRXDA	28
N
N//#define	GPIO_NO_SCITXDA	12
N#define	GPIO_NO_SCITXDA	29
N
N
N/*-----------------------------------------------------------------------------
N      Specify the PLL control register (PLLCR) and divide select (DIVSEL) value.
N-----------------------------------------------------------------------------*/
N
N//#define DSP28_DIVSEL   0 // Enable /4 for SYSCLKOUT
N//#define DSP28_DIVSEL   1 // Disable /4 for SYSCKOUT
N#define DSP28_DIVSEL   2 // Enable /2 for SYSCLKOUT
N//#define DSP28_DIVSEL   3 // Enable /1 for SYSCLKOUT
N
N
N#define DSP28_PLLCR   12    // Uncomment for 60 MHz devices [60 MHz = (10MHz * 12)/2]
N//#define DSP28_PLLCR   11
N//#define DSP28_PLLCR   10
N//#define DSP28_PLLCR    9
N//#define DSP28_PLLCR    8      // Uncomment for 40 MHz devices [40 MHz = (10MHz * 8)/2]
N//#define DSP28_PLLCR    7
N//#define DSP28_PLLCR    6
N//#define DSP28_PLLCR    5
N//#define DSP28_PLLCR    4
N//#define DSP28_PLLCR    3
N//#define DSP28_PLLCR    2
N//#define DSP28_PLLCR    1
N//#define DSP28_PLLCR    0  // PLL is bypassed in this mode
N//----------------------------------------------------------------------------
N
N/*-----------------------------------------------------------------------------
N      Specify the clock rate of the CPU (SYSCLKOUT) in nS.
N
N      Take into account the input clock frequency and the PLL multiplier
N      selected in step 1.
N
N      Use one of the values provided, or define your own.
N      The trailing L is required tells the compiler to treat
N      the number as a 64-bit value.
N
N      Only one statement should be uncommented.
N
N      Example:   60 MHz devices:
N                 CLKIN is a 10 MHz crystal or internal 10 MHz oscillator
N
N                 In step 1 the user specified PLLCR = 0xC for a
N                 60 MHz CPU clock (SYSCLKOUT = 60 MHz).
N
N                 In this case, the CPU_RATE will be 16.667L
N                 Uncomment the line: #define CPU_RATE 16.667L
N
N-----------------------------------------------------------------------------*/
N
N#define CPU_RATE   16.667L   // for a 60MHz CPU clock speed (SYSCLKOUT)
N//#define CPU_RATE   20.000L   // for a 50MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   25.000L   // for a 40MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   33.333L   // for a 30MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   41.667L   // for a 24MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   50.000L   // for a 20MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   66.667L   // for a 15MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE  100.000L   // for a 10MHz CPU clock speed  (SYSCLKOUT)
N
N#if 0
S//----------------------------------------------------------------------------
S
S// The following pointer to a function call calibrates the ADC and internal oscillators
S#define Device_cal (void   (*)(void))0x3D7C80
S
S//---------------------------------------------------------------------------
S// Include Example Header Files:
S//
S
S#include "DSP2803x_GlobalPrototypes.h"         // Prototypes for global functions within the
S                                               // .c files.
S#include "DSP2803x_EPwm_defines.h"             // Macros used for PWM examples.
S#include "DSP2803x_I2C_defines.h"              // Macros used for I2C examples.
S#include "DSP2803x_Cla_Defines.h"              // Macros used for CLA examples.
S
S
S#define   PARTNO_28030PAG   0xAA
S#define   PARTNO_28030PN    0xAB
S
S#define   PARTNO_28031PAG   0xAE
S#define   PARTNO_28031PN    0xAF
S
S#define   PARTNO_28032PAG   0xB2
S#define   PARTNO_28032PN    0xB3
S
S#define   PARTNO_28033PAG   0xB6
S#define   PARTNO_28033PN    0xB7
S
S#define   PARTNO_28034PAG   0xBA
S#define   PARTNO_28034PN    0xBB
S
S#define   PARTNO_28035PAG   0xBE
S#define   PARTNO_28035PN    0xBF
S
S// Include files not used with DSP/BIOS
S#ifndef DSP28_BIOS
S#include "DSP2803x_DefaultISR.h"
S#endif
N#endif
N
Nextern void DSP28x_usDelay(unsigned long Count);
N// DO NOT MODIFY THIS LINE.
N#define DELAY_US(A)  DSP28x_usDelay(((((long double) A * 1000.0L) / (long double)CPU_RATE) - 9.0L) / 5.0L)
N
N#endif	/* INC_config_H */
N
N/*** end of file : config.h ***/
L 14 "../src/bsp/tms320f28035/pwmDrv.c" 2
N
N#include "gpioDrv.h"
L 1 "..\src\bsp\tms320f28035\gpioDrv.h" 1
N/*** gpioDrv.h - TMS320F28035(piccolo) GPIO driver ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/09 mimu
N              First Version
N */
N
N#ifndef	INC_gpioDrv_H
N#define	INC_gpioDrv_H
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
N#define	GPIO_MAX	44
N#define	GPIO_NUM	45
N
Nint gpioInit( void );
Nint gpioConfig( int no, int mode );
N#define	GPIO_MODE_GPIO			0x001
N#define	GPIO_MODE_1				0x002
N#define	GPIO_MODE_2				0x004
N#define	GPIO_MODE_3				0x008
N
N#define	GPIO_MODE_IN			0x010
N#define	GPIO_MODE_OUT			0x020
N#define	GPIO_MODE_PULLUP_DIS	0x040
N#define	GPIO_MODE_PULLUP		0x080
N
N#define	GPIO_MODE_QUALIFIER_0	0x100
N#define	GPIO_MODE_QUALIFIER_1	0x200
N#define	GPIO_MODE_QUALIFIER_2	0x400
N#define	GPIO_MODE_QUALIFIER_3	0x800
N#define	GPIO_MODE_QUALIFILER(_x)	(0x100<<(_x))&0x0f00))
N
N#define	GPIO_CTRL_SET		0
N#define	GPIO_CTRL_CLR		1
N#define	GPIO_CTRL_TOGGLE	2
N#define	GPIO_CTRL_GET		3
Nint gpioCtrl( int no, int ctrl );
N
N//int gpioControl( int no, int bHigh );
N#define	gpioControl( _no, _bH )	(bH?gpioCtrl(_no, GPIO_CTRL_SET):gpioCtrl(_no, GPIO_CTRL_CLR))
N//int gpioSet( int no );
N#define	gpioSet( _no )		gpioCtrl( _no, GPIO_CTRL_SET )
N//int gpioClear( int no );
N#define	gpioClear( _no )	gpioCtrl( _no, GPIO_CTRL_CLR )
N//int gpioToggle( int no );
N#define	gpioToggle( _no )	gpioCtrl( _no, GPIO_CTRL_TOGGLE )
N//int gpioGet( int no );
N#define	gpioGet( _no )		gpioCtrl( _no, GPIO_CTRL_GET )
N
Nint gpioCtrlRegSet( int reg, int value );
N#define	GPIO_CTRLREG_QUALPRD_0_7	0		/* GPIO 0-7 */
N#define	GPIO_CTRLREG_QUALPRD_8_15	1		/* GPIO 8-15 */
N#define	GPIO_CTRLREG_QUALPRD_16_23	2		/* GPIO 16-23 */
N#define	GPIO_CTRLREG_QUALPRD_24_31	3		/* GPIO 24-31 */
N
N#define	GPIO_CTRLREG_QUBLPRD_32_39	4		/* GPIO 32-39 */
N#define	GPIO_CTRLREG_QUBLPRD_40_44	5		/* GPIO 32-44 */
N
N#ifdef	__cplusplus
S} /* extern "C" */
N#endif
N
N#endif	/* INC_gpioDrv_H */
N
N/*** end of file : gpioDrv.h ***/
L 16 "../src/bsp/tms320f28035/pwmDrv.c" 2
N#include "pwmDrv.h"
L 1 "..\src\bsp\tms320f28035\pwmDrv.h" 1
N/*** pwmDrv.h - TMS320F28035 ePWM driver ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/03/05 mimu
N              First Version
N */
N
N/*** NOTE ***/
N#ifndef	INC_pwmDrv_H
N#define	INC_pwmDrv_H
N
N#include "config.h"
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
N#define	PWM_CH_1A	0
N#define	PWM_CH_1B	1
N#define	PWM_CH_2A	2
N#define	PWM_CH_2B	3
N#define	PWM_CH_3A	4
N#define	PWM_CH_3B	5
N#define	PWM_CH_4A	6
N#define	PWM_CH_4B	7
N#define	PWM_CH_5A	8
N#define	PWM_CH_5B	9
N#define	PWM_CH_6A	10
N#define	PWM_CH_6B	11
N#define	PWM_CH_7A	12
N#define	PWM_CH_7B	13
N
N#define	PWM_CH_NUM	14
N
Nint pwm_init( void );
Nint pwm_ch_init( int ch );
Nint pwm_duty( int ch, float duty );
N
N#ifdef	__cplusplus
S} /* extern "C" */
N#endif
N
N#endif	/* INC_pwmDrv_H */
N
N/*** end of file : pwmDrv.h ***/
L 17 "../src/bsp/tms320f28035/pwmDrv.c" 2
N
N
N/*** DEFINE ***/
N#if 1
N/* sysclk = 60Mhz -> 60/1 / 600 =>100K */
N#define	TBCTL_DIV_VAL	(TBCTL_HSPCLKDIV_1|TBCTL_CLKDIV_1)
N#define	TBPRD_VAL	600
N#endif
N
N
N#define	PWM1_ADRS	0x6800	/* ePWM1 + HRPWM1 Registers 0x6800 - 0x683F 64 (3) */
N#define	PWM2_ADRS	0x6840	/* ePWM2 + HRPWM2 Registers 0x6840 - 0x687F 64 (3) */
N#define	PWM3_ADRS	0x6880	/* ePWM3 + HRPWM3 Registers 0x6880 - 0x68BF 64 (3) */
N#define	PWM4_ADRS	0x68c0	/* ePWM4 + HRPWM4 Registers 0x68C0 - 0x68FF 64 (3) */
N#define	PWM5_ADRS	0x6900	/* ePWM5 + HRPWM5 Registers 0x6900 - 0x693F 64 (3) */
N#define	PWM6_ADRS	0x6940	/* ePWM6 + HRPWM6 Registers 0x6940 - 0x697F 64 (3) */
N#define	PWM7_ADRS	0x6980	/* ePWM7 + HRPWM7 Registers 0x6980 - 0x69BF 64 (3) */
N
N
Ntypedef struct pwm_reg_t {
N	                                      /* name         addr  size [shadow:EALLOW] */
N	/*
N	 * Time-Base Submodule Registers
N	 */
N	volatile unsigned short tbctl;        /* TBCTL        0x0000 1 [No :   ] Time-Base Control Register */
N#define	TBCTL_STOP_0		0			/* Stop after the next time-base counter increment or decrement */
N#define	TBCTL_STOP_1		(1<<14)		/* Stop when counter completes a whole cycle */
N#define	TBCTL_FREE			(2<<14)		/* Free run */
N#define	TBCTL_PHSDIR		(1<<13)		/* Phase Direction Bit. */
N
N#define	TBCTL_CLKDIV_1		(0<<10)		/* Time-base Clock Prescale (/1) */
N#define	TBCTL_CLKDIV_2		(1<<10)		/* Time-base Clock Prescale (/2) */
N#define	TBCTL_CLKDIV_4		(2<<10)		/* Time-base Clock Prescale (/4) */
N#define	TBCTL_CLKDIV_8		(3<<10)		/* Time-base Clock Prescale (/8) */
N#define	TBCTL_CLKDIV_16		(4<<10)		/* Time-base Clock Prescale (/16) */
N#define	TBCTL_CLKDIV_32		(5<<10)		/* Time-base Clock Prescale (/32) */
N#define	TBCTL_CLKDIV_64		(6<<10)		/* Time-base Clock Prescale (/64) */
N#define	TBCTL_CLKDIV_128	(7<<10)		/* Time-base Clock Prescale (/128) */
N
N#define	TBCTL_HSPCLKDIV_1	(0<<7)		/* High Speed Time-base Clock Prescale (/1) */
N#define	TBCTL_HSPCLKDIV_2	(1<<7)		/* High Speed Time-base Clock Prescale (/2) */
N#define	TBCTL_HSPCLKDIV_4	(2<<7)		/* High Speed Time-base Clock Prescale (/4) */
N#define	TBCTL_HSPCLKDIV_8	(3<<7)		/* High Speed Time-base Clock Prescale (/8) */
N#define	TBCTL_HSPCLKDIV_16	(4<<7)		/* High Speed Time-base Clock Prescale (/16) */
N#define	TBCTL_HSPCLKDIV_32	(5<<7)		/* High Speed Time-base Clock Prescale (/32) */
N#define	TBCTL_HSPCLKDIV_64	(6<<7)		/* High Speed Time-base Clock Prescale (/64) */
N#define	TBCTL_HSPCLKDIV_128	(7<<7)		/* High Speed Time-base Clock Prescale (/128) */
N
N#define	TBCTL_SYNCOSEL_EPWMxSYNC	(0<<4)	/* Synchronization Output Select : EPWMxSYNC */
N#define	TBCTL_SYNCOSEL_CTR_ZERO		(1<<4)	/* Synchronization Output Select : CTR = zero */
N#define	TBCTL_SYNCOSEL_CTR_CMPB		(2<<4)	/* Synchronization Output Select : CTR = CMPB */
N#define	TBCTL_SYNCOSEL_DISABLE		(3<<4)	/* Synchronization Output Select : Disable */
N
N#define	TBCTL_PRDLD			(1<<3)
N#define	TBCTL_PHSEN			(1<<2)
N
N#define	TBCTL_CTRMODE_UP		(0)
N#define	TBCTL_CTRMODE_DOWN		(1)
N#define	TBCTL_CTRMODE_UP_DOWN	(2)
N#define	TBCTL_CTRMODE_STOP		(3)
N
N	volatile unsigned short tbsts;        /* TBSTS        0x0001 1 [No :   ] Time-Base Status Register */
N#define	TBSTS_CTRMAX	(1<<2)
N#define	TBSTS_SYNCI		(1<<1)
N#define	TBSTS_CTRDIR	(1<<0)
N
N	volatile unsigned short tbphshr;      /* TBPHSHR      0x0002 1 [No :   ] Extension for HRPWM Phase Register (2) */
N	volatile unsigned short tbphs;        /* TBPHS        0x0003 1 [No :   ] Time-Base Phase Register */
N	volatile unsigned short tbctr;        /* TBCTR        0x0004 1 [No :   ] Time-Base Counter Register */
N	volatile unsigned short tbprd;        /* TBPRD        0x0005 1 [Yes:   ] Time-Base Period Register */
N	volatile unsigned short tbprdhr;      /* TBPRDHR      0x0006 1 [Yes:   ] Time Base Period High Resolution Register (3) */
N
N
N	/*
N	 * Counter-Compare Submodule Registers
N	 */
N	volatile unsigned short cmpctl;       /* CMPCTL       0x0007 1 [No :   ] Counter-Compare Control Register */
N#define	CMPCTL_SHDWBFULL	(1<<9)	/* Counter-compare B (CMPB) Shadow Register Full Status Flag */
N#define	CMPCTL_SHDWAFULL	(1<<8)	/* Counter-compare A (CMPA) Shadow Register Full Status Flag */
N#define	CMPCTL_SHDWBMODE	(1<<6)	/* Counter-compare B (CMPB) Register Operating Mode */
N#define	CMPCTL_SHDWAMODE	(1<<4)	/* Counter-compare A (CMPA) Register Operating Mode */
N
N#define	CMPCTL_LOADBMODE_CTR_ZERO		(0<<2)		/* Load on CTR = Zero: Time-base counter equal to zero (TBCTR = 0x0000) */
N#define	CMPCTL_LOADBMODE_CTR_PRD		(1<<2)		/* Load on CTR = PRD: Time-base counter equal to period (TBCTR = TBPRD) */
N#define	CMPCTL_LOADBMODE_CTR_ZRO_PRD	(2<<2)		/* Load on either CTR = Zero or CTR = PRD */
N#define	CMPCTL_LOADBMODE_FREEZE			(3<<2)		/* Freeze (no loads possible) */
N
N#define	CMPCTL_LOADAMODE_CTR_ZERO		(0<<2)		/* Load on CTR = Zero: Time-base counter equal to zero (TBCTR = 0x0000) */
N#define	CMPCTL_LOADAMODE_CTR_PRD		(1<<2)		/* Load on CTR = PRD: Time-base counter equal to period (TBCTR = TBPRD) */
N#define	CMPCTL_LOADAMODE_CTR_ZRO_PRD	(2<<2)		/* Load on either CTR = Zero or CTR = PRD */
N#define	CMPCTL_LOADAMODE_FREEZE			(3<<2)		/* Freeze (no loads possible) */
N
N
N	volatile unsigned short cmpahr;       /* CMPAHR       0x0008 1 [Yes:   ] Extension for HRPWM Counter-Compare A Register (2) */
N	volatile unsigned short cmpa;         /* CMPA         0x0009 1 [Yes:   ] Counter-Compare A Register */
N	volatile unsigned short cmpb;         /* CMPB         0x000A 1 [Yes:   ] Counter-Compare B Register */
N
N
N	/*
N	 * Action-Qualifier Submodule Registers
N	 */
N	volatile unsigned short aqctla;       /* AQCTLA       0x000B 1 [No :   ] Action-Qualifier Control Register for Output A (EPWMxA) */
N	volatile unsigned short aqctlb;       /* AQCTLB       0x000C 1 [No :   ] Action-Qualifier Control Register for Output B (EPWMxB) */
N
N#define	AQCTLx_xxx_NOTHING	0		/* Do nothing (action disabled) */
N#define	AQCTLx_xxx_CLEAR	1		/* Clear: force EPWMxA output low. */
N#define	AQCTLx_xxx_SET		2		/* Set: force EPWMxA output high. */
N#define	AQCTLx_xxx_TOGGLE	3		/* Toggle EPWMxA output */
N
N#define	AQCTLx_CBD(_v)		((_v)<<10)
N#define	AQCTLx_CBU(_v)		((_v)<<8)
N#define	AQCTLx_CAD(_v)		((_v)<<6)
N#define	AQCTLx_CAU(_v)		((_v)<<4)
N#define	AQCTLx_PRD(_v)		((_v)<<2)
N#define	AQCTLx_ZRO(_v)		( _v    )
N
N	volatile unsigned short aqsfrc;       /* AQSFRC       0x000D 1 [No :   ] Action-Qualifier Software Force Register */
N
N#define	AQSFRC_RLDCSF_ZERO			(0<<6)	/* Load on event counter equals zero */
N#define	AQSFRC_RLDCSF_PERIOD		(1<<6)	/* Load on event counter equals period */
N#define	AQSFRC_RLDCSF_ZERO_PERIOD	(2<<6)	/* Load on event counter equals zero or counter equals period */
N#define	AQSFRC_RLDCSF_IMMEDIATELY	(3<<6)	/* Load immediately */
N
N#define	AQSFRC_OTSFB		(1<<5)	/* One-Time Software Forced Event on Output B */
N#define	AQSFRC_OTSFA		(1<<2)		/* One-Time Software Forced Event on Output A */
N
N#define	AQSFRC_ACTSFx_NOTHING	0		/* Does nothing (action disabled) */
N#define	AQSFRC_ACTSFx_CLEAR		1		/* Clear (low) */
N#define	AQSFRC_ACTSFx_SET		2		/* Set (high) */
N#define	AQSFRC_ACTSFx_TOGGLE	3		/* Toggle (Low -> High, High -> Low) */
N
N#define	AQSFRC_ACTSFB(_v)	((_v)<<3)
N#define	AQSFRC_ACTSFA(_v)	((_v)<<0)
N
N	volatile unsigned short aqcsfrc;      /* AQCSFRC      0x000E 1 [Yes:   ] Action-Qualifier Continuous S/W Force Register Set */
N#define	AQCSFCR_CSFx_DISABLED	0	/* Forcing disabled, i.e., has no effect */
N#define	AQCSFCR_CSFx_LOW		1	/* Forces a continuous low on output x */
N#define	AQCSFCR_CSFx_HIGH		2	/* Forces a continuous high on output x */
N#define	AQCSFCR_CSFx_DISABLE	3	/* Software forcing is disabled and has no effect */
N
N#define	AQCSFCR_CSFB(_v)		((_v)<<2)
N#define	AQCSFCR_CSFA(_v)		((_v)<<0)
N
N
N	/*
N	 * Dead-Band Generator Submodule Registers
N	 */
N	volatile unsigned short dbctl;        /* DBCTL        0x000F 1 [No :   ] Dead-Band Generator Control Register */
N#define	DBCTL_HALFCYCLE					(1<<15)		/* Half Cycle Clocking Enable Bit: */
N#define	DBCTL_A_BOTH					(0<<4)		/* EPWMxA In (from the action-qualifier) is the source for both falling-edge
N													 * and rising-edge delay.
N													 */
N#define	DBCTL_IN_MODE_A_FALL_B_RISE		(1<<4)		/* EPWMxB In (from the action-qualifier) is the source for rising-edge delayed signal.
N													 * EPWMxA In (from the action-qualifier) is the source for falling-edge delayed signal.
N													 */
N#define	DBCTL_IN_MODE_A_RISE_B_FALL		(2<<4)		/* EPWMxA In (from the action-qualifier) is the source for rising-edge delayed signal.
N													 * EPWMxB In (from the action-qualifier) is the source for falling-edge delayed signal.
N													 */
N#define	DBCTL_IN_MODE_B_BOTH			(3<<4)		/* EPWMxB In (from the action-qualifier) is the source for both rising-edge delay and falling-edge delayed signal. */
N#define	DBCTL_POL_SEL_AH				(0<<2)		/* Active high (AH) mode. Neither EPWMxA nor EPWMxB is inverted (default). */
N#define	DBCTL_POL_SEL_ALC				(1<<2)		/* 01 Active low complementary (ALC) mode. EPWMxA is inverted. */
N#define	DBCTL_POL_SEL_AHC				(2<<2)		/* Active high complementary (AHC). EPWMxB is inverted. */
N#define	DBCTL_POL_SEL_AL				(3<<2)		/* Active low (AL) mode. Both EPWMxA and EPWMxB are inverted. */
N#define	DBCTL_OUT_MODE_BYPASS			(0<<0)		/* Dead-band generation is bypassed for both output signals. */
N#define	DBCTL_OUT_MODE_FALL				(1<<0)		/* The falling-edge delayed signal is seen on output EPWMxB */
N#define	DBCTL_OUT_MODE_RISE				(2<<0)		/* The rising-edge delayed signal is seen on output EPWMxA. */
N#define	DBCTL_OUT_MODE_BOTH				(3<<0)		/* Dead-band is fully enabled for both rising-edge delay on output EPWMxA and falling-edge delay on output EPWMxB. */
N
N	volatile unsigned short dbred;        /* DBRED        0x0010 1 [No :   ] Dead-Band Generator Rising Edge Delay Count Register */
N	volatile unsigned short dbfed;        /* DBFED        0x0011 1 [No :   ] Dead-Band Generator Falling Edge Delay Count Register */
N
N
N	/*
N	 * Trip-Zone Submodule Registers
N	 */
N	volatile unsigned short tzsel;        /* TZSEL        0x0012 1 [   :Yes] Trip-Zone Select Register */
N#define	TZSEL_DCBEVT1	(1<<15)			/* Digital Compare Output B Event 1 Select */
N#define	TZSEL_DCAEVT1	(1<<14)			/* Digital Compare Output A Event 1 Select */
N#define	TZSEL_OSHT6		(1<<13)			/* Trip-zone 6 (TZ6) Select */
N#define	TZSEL_OSHT5		(1<<12)			/* Trip-zone 5 (TZ5) Select */
N#define	TZSEL_OSHT4		(1<<11)			/* Trip-zone 4 (TZ4) Select */
N#define	TZSEL_OSHT3		(1<<10)			/* Trip-zone 3 (TZ3) Select */
N#define	TZSEL_OSHT2		(1<<9)			/* Trip-zone 2 (TZ2) Select */
N#define	TZSEL_OSHT1		(1<<8)			/* Trip-zone 1 (TZ1) Select */
N#define	TZSEL_DCBEVT2	(1<<7)			/* Digital Compare Output B Event 2 Select */
N#define	TZSEL_DCAEVT2	(1<<6)			/* Digital Compare Output A Event 2 Select */
N#define	TZSEL_CBC6		(1<<5)			/* Trip-zone 6 (TZ6) Select */
N#define	TZSEL_CBC5		(1<<4)			/* Trip-zone 5 (TZ5) Select */
N#define	TZSEL_CBC4		(1<<3)			/* Trip-zone 4 (TZ4) Select */
N#define	TZSEL_CBC3		(1<<2)			/* Trip-zone 3 (TZ3) Select */
N#define	TZSEL_CBC2		(1<<1)			/* Trip-zone 2 (TZ2) Select */
N#define	TZSEL_CBC1		(1<<0)			/* Trip-zone 1 (TZ1) Select */
N
N	volatile unsigned short tzdcsel;      /* TZDCSEL      0x0013 1 [   :Yes] Trip Zone Digital Compare Select Register */
N#define	TZDCSEL_DCxEVTx_DISABLE		0	/* Event disabled */
N#define	TZDCSEL_DCxEVTx_HL_Lx		1	/* DCAH = low, DCAL = don't care */
N#define	TZDCSEL_DCxEVTx_HH_Lx		2	/* DCAH = high, DCAL = don't care */
N#define	TXDCSEL_DCxEVTx_Hx_LL		3	/* DCAH = don't care, DCAL = low */
N#define	TXDCSEL_DCxEVTx_Hx_LH		4	/* DCAH = don't care, DCAL = high */
N#define	TXDCSEL_DCxEVTx_HL_LH		5	/* DCAH = low, DCAL = high */
N
N#define	TXDCSEL_DCBEVT2(_v)		((_v)<<9)	/* Digital Compare Output B Event 2 Selection */
N#define	TXDCSEL_DCBEVT1(_v)		((_v)<<6)	/* Digital Compare Output B Event 1 Selection */
N#define	TXDCSEL_DCAEVT2(_v)		((_v)<<3)	/* Digital Compare Output A Event 2 Selection */
N#define	TXDCSEL_DCAEVT1(_v)		((_v)<<0)	/* Digital Compare Output A Event 1 Selection */
N
N
N	volatile unsigned short tzctl;        /* TZCTL        0x0014 1 [   :Yes] Trip-Zone Control Register (3) */
N#define	TZCTL_xxxx_IMPEDANCE	0	/* High-impedance */
N#define	TZCTL_xxxx_HIGH			1	/* Force to a high state. */
N#define	TZCTL_xxxx_LOW			2	/* Force to a low state. */
N#define	TZCTL_xxxx_DISABLE		3	/* Do Nothing, trip action is disabled */
N
N#define	TZCTL_DCBEVT2(_v)	((_v)<<10)		/* Digital Compare Output B Event 2 Action On EPWMxB: */
N#define	TZCTL_DCBEVT1(_v)	((_v)<<8)		/* Digital Compare Output B Event 1 Action On EPWMxB: */
N#define	TZCTL_DCAEVT2(_v)	((_v)<<6)		/* Digital Compare Output A Event 2 Action On EPWMxA: */
N#define	TZCTL_DCAEVT1(_v)	((_v)<<4)		/* Digital Compare Output A Event 1 Action On EPWMxA: */
N#define	TZCTL_TZB(_v)		((_v)<<2)		/* When a trip event occurs the following action is taken on output EPWMxB. */
N#define	TZCTL_TZA(_v)		((_v)<<0)		/* When a trip event occurs the following action is taken on output EPWMxA. */
N
N
N	volatile unsigned short tzeint;       /* TZEINT       0x0015 1 [   :Yes] Trip-Zone Enable Interrupt Register (3) */
N	volatile unsigned short tzflg;        /* TZFLG        0x0016 1 [   :   ]Trip-Zone Flag Register (3) */
N	volatile unsigned short tzclr;        /* TZCLR        0x0017 1 [   :Yes] Trip-Zone Clear Register (3) */
N	volatile unsigned short tzfrc;        /* TZFRC        0x0018 1 [   :Yes] Trip-Zone Force Register (3) */
N#define	TZ_INT_DCBEVT2		(1<<6)		/* Digital Comparator Output B Event 2 Interrupt */
N#define	TZ_INT_DCBEVT1		(1<<5)		/* Digital Comparator Output B Event 1 Interrupt */
N#define	TZ_INT_DCAEVT2		(1<<4)		/* Digital Comparator Output A Event 2 Interrupt */
N#define	TZ_INT_DCAEVT1		(1<<3)		/* Digital Comparator Output A Event 1 Interrupt */
N#define	TZ_INT_OST			(1<<2)		/* Trip-zone One-Shot Interrupt */
N#define	TZ_INT_CBC			(1<<1)		/* Trip-zone Cycle-by-Cycle Interrupt */
N#define	TZ_INT				(1<<0)		/* Latched Trip Interrupt */
N
N	/*
N	 * Event-Trigger Submodule Registers
N	 */
N	volatile unsigned short etsel;        /* ETSEL        0x0019 1 [   :   ] Event-Trigger Selection Register */
N#define	ETSEL_SOCBEN		(1<<15)		/* Enable the ADC Start of Conversion B (EPWMxSOCB) Pulse */
N#define	ETSEL_SOCAEN		(1<<11)		/* Enable the ADC Start of Conversion A (EPWMxSOCA) Pulse */
N#define	ETSEL_INTEN		(1<<3)		/* Enable ePWM Interrupt (EPWMx_INT) Generation */
N
N#define	ETSEL_xxxSEL_DCBEVT1				0		/* Enable DCBEVT1.soc event */
N#define	ETSEL_xxxSEL_COUNTER_ZERO			1		/* Enable event time-base counter equal to zero. (TBCTR = 0x0000) */
N#define	ETSEL_xxxSEL_COUNTER_PERIOD		2		/* Enable event time-base counter equal to period (TBCTR = TBPRD) */
N#define	ETSEL_xxxSEL_COUNTER_ZERO_PERIOD	3		/* Enable event time-base counter equal to zero or period (TBCTR = 0x0000 or TBCTR = TBPRD). */
N#define	ETSEL_xxxSEL_CMPA_INC				4		/* Enable event time-base counter equal to CMPA when the timer is incrementing. */
N#define	ETSEL_xxxSEL_CMPA_DEC				5		/* Enable event time-base counter equal to CMPA when the timer is decrementing. */
N#define	ETSEL_xxxSEL_CMPB_INC				6		/* Enable event: time-base counter equal to CMPB when the timer is incrementing. */
N#define	ETSEL_xxxSEL_CMPB_DEC				7		/* Enable event: time-base counter equal to CMPB when the timer is decrementing. */
N
N#define	ETSEL_SOCBSEL(_v)				((_v)<<12)	/* EPWMxSOCB Selection Options */
N#define	ETSEL_SOCASEL(_v)				((_v)<<8)	/* EPWMxSOCA Selection Options */
N#define	ETSEL_INTSEL(_v)				((_v)<<0)	/* ePWM Interrupt (EPWMx_INT) Selection Options */
N
N	volatile unsigned short etps;         /* ETPS         0x001A 1 [   :   ] Event-Trigger Pre-Scale Register */
N#define	ETPS_SOCBCNT(_reg)				(((_reg)>>14)&0x03)	/* ePWM ADC Start-of-Conversion B Event (EPWMxSOCB) Counter Register */
N#define	ETPS_SOCBPRD(_v)				((_v)<<12)			/* ePWM ADC Start-of-Conversion B Event (EPWMxSOCB) Period Select */
N#define	ETPS_SOCACNT(_reg)				(((_reg)>>10)&0x03)	/* ePWM ADC Start-of-Conversion A Event (EPWMxSOCA) Counter Register */
N#define	ETPS_SOCAPRD(_v)				((_v)<<8)			/* ePWM ADC Start-of-Conversion A Event (EPWMxSOCA) Period Select */
N#define	ETPS_INTCNT(_reg)				(((_reg)>>2)&0x03)	/* ePWM Interrupt Event (EPWMx_INT) Counter Register */
N#define	ETPS_INTPRD(_v)					((_v)<<0)			/* ePWM Interrupt (EPWMx_INT) Period Select */
N
N	volatile unsigned short etflg;        /* ETFLG        0x001B 1 [   :   ] Event-Trigger Flag Register */
N	volatile unsigned short etclr;        /* ETCLR        0x001C 1 [   :   ] Event-Trigger Clear Register */
N	volatile unsigned short etfrc;        /* ETFRC        0x001D 1 [   :   ] Event-Trigger Force Register */
N#define	ETxxx_SOCB		(1<<3)		/* Latched ePWM ADC Start-of-Conversion B (EPWMxSOCB) Status Flag */
N#define	ETxxx_SOCA		(1<<2)		/* Latched ePWM ADC Start-of-Conversion A (EPWMxSOCA) Status Flag */
N#define	ETxxx_INT		(1<<0)		/* Latched ePWM Interrupt (EPWMx_INT) Status Flag */
N
N
N	/*
N	 * PWM-Chopper Submodule Registers
N	 */
N	volatile unsigned short pcctl;        /* PCCTL        0x001E 1 [   :   ] PWM-Chopper Control Register */
N#define	PCCTL_CHPDUTY(_v)		((_v)<<8)		/* CHPDUTY Chopping Clock Duty Cycle */
N#define	PCCTL_CHPFREQ(_v)		((_v)<<5)		/* Chopping Clock Frequency */
N#define	PCCTL_OSHTWTH(_v)		((_v)<<1)		/* One-Shot Pulse Width */
N#define	PCCTLCHPEN				(1<<0)			/* PWM-chopping Enable */
N
N	         unsigned short __dummy_1f__;
N
N	/*
N	 * High-Resolution Pulse Width Modulator (HRPWM) Extension Registers
N	 */
N	volatile unsigned short hrcnfg;       /* HRCNFG       0x0020 1 [   :Yes] HRPWM Configuration Register (2) (3) */
N	volatile unsigned short hrpwr;        /* HRPWR        0x0021 1 [   :Yes] HRPWM Power Register (3) (4) */
N	         unsigned short __dumy_22__;
N	         unsigned short __dumy_23__;
N	         unsigned short __dumy_24__;
N	         unsigned short __dumy_25__;
N	volatile unsigned short hrmstep;      /* HRMSTEP      0x0026 1 [   :Yes] HRPWM MEP Step Register(3) (4) */
N	         unsigned short __dumy_27__;
N	volatile unsigned short hrpctl;       /* HRPCTL       0x0028 1 [   :Yes] High Resolution Period Control Register(3) */
N#define	HRPCTL_TBPHSHRLOADE		(1<<2)	/* TBPHSHR Load Enable */
N#define	HRPCTL_HRPE				(1<<0)	/* TBPHSHR Load Enable */
N
N	         unsigned short __dumy_29__;
N	volatile unsigned short tbprdhrm;     /* TBPRDHRM     0x002A 1 [Writes:] Time Base Period High Resolution Register Mirror(3) */
N	volatile unsigned short tbprdm;       /* TBPRDM       0x002B 1 [Writes:] Time Base Period Register Mirror */
N	volatile unsigned short cmpahrm;      /* CMPAHRM      0x002C 1 [Writes:] Compare A High Resolution Register Mirror(3) */
N	volatile unsigned short cmpam;        /* CMPAM        0x002D 1 [Writes:] Compare A Register Mirror */
N	         unsigned short __dumy_2e__;
N	         unsigned short __dumy_2f__;
N
N	/*
N	 * Digital Compare Event Registers
N	 */
N	volatile unsigned short dctripsel;    /* DCTRIPSEL    0x0030 1 [   :Yes] Digital Compare Trip Select Register */
N#define	DCTRIPSEL_DCxxCOMPSEL_TZ1		0	/* TZ1 input */
N#define	DCTRIPSEL_DCxxCOMPSEL_TZ2		1	/* TZ2 input */
N#define	DCTRIPSEL_DCxxCOMPSEL_TZ3		2	/* TZ3 input */
N#define	DCTRIPSEL_DCxxCOMPSEL_COM1OUT	8	/* COMP1OUT input */
N#define	DCTRIPSEL_DCxxCOMPSEL_COM2OUT	9	/* COMP2OUT input */
N#define	DCTRIPSEL_DCxxCOMPSEL_COM3OUT	10	/* COMP3OUT input */
N
N#define	DCTRIPSEL_DCBLCOMPSEL(_v)		((_v)<<12)		/* Digital Compare B Low Input Select */
N#define	DCTRIPSEL_DCBHCOMPSEL(_v)		((_v)<<8)		/* Digital Compare B High Input Select */
N#define	DCTRIPSEL_DCALCOMPSEL(_v)		((_v)<<4)		/* Digital Compare A Low Input Select */
N#define	DCTRIPSEL_DCAHCOMPSEL(_v)		((_v)<<0)		/* Digital Compare A High Input Select */
N
N	volatile unsigned short dcactl;       /* DCACTL       0x0031 1 [   :Yes] Digital Compare A Control Register */
N	volatile unsigned short dcbctl;       /* DCBCTL       0x0032 1 [   :Yes] Digital Compare B Control Register */
N#define	DCxCTL_EVT2FRCSYNCSEL	(1<<9)		/* DCxEVT2 Force Synchronization Signal Select */
N#define	DCxCTL_EVT2SRCSEL		(1<<8)		/* DCxEVT2 Source Signal Select */
N#define	DCxCTL_EVT1SYNCE		(1<<3)		/* DCxEVT1 SYNC, Enable/Disable */
N#define	DCxCTL_EVT1SOCE			(1<<2)		/* DCxEVT1 SOC, Enable/Disable */
N#define	DCxCTL_EVT1FRCSYNCSEL	(1<<1)		/* DCxEVT1 Force Synchronization Signal Select */
N#define	DCxCTL_EVT1SRCSEL		(1<<0)		/* DCxEVT1 Source Signal Select */
N
N
N	volatile unsigned short dcfctl;       /* DCFCTL       0x0033 1 [   :Yes] Digital Compare Filter Control Register */
N#define	DCFCTL_PULSESEL_PERIOD	(0<<4)		/* Time-base counter equal to period (TBCTR = TBPRD) */
N#define	DCFCTL_PULSESEL_ZERO	(1<<4)		/* Time-base counter equal to zero (TBCTR = 0x0000) */
N#define	DCFCTL_BLANKINV			(1<<3)		/* Blanking Window Inversion */
N#define	DCFCTL_BLANKE			(1<<2)		/* Blanking Window Enable/Disable */
N#define	DCFCTL_DCAEVT1			(0<<0)		/* Source Is DCAEVT1 Signal */
N#define	DCFCTL_DCAEVT2			(1<<0)		/* Source Is DCAEVT2 Signal */
N#define	DCFCTL_DCBEVT1			(2<<0)		/* Source Is DCBEVT1 Signal */
N#define	DCFCTL_DCBEVT2			(3<<0)		/* Source Is DCBEVT2 Signal */
N
N	volatile unsigned short dccapctl;     /* DCCAPCTL     0x0034 1 [   :Yes] Digital Compare Capture Control Register */
N#define	DCCAPCTL_SHDWMODE		(1<<1)		/* TBCTR Counter Capture Shadow Select Mode */
N#define	DCCAPCTL_CAPE		(1<<0)		/* TBCTR Counter Capture Enable/Disable */
N
N	volatile unsigned short dcfoffset;    /* DCFOFFSET    0x0035 1 [Writes:] Digital Compare Filter Offset Register */
N	volatile unsigned short dcfoffsetcnt; /* DCFOFFSETCNT 0x0036 1 [   :   ] Digital Compare Filter Offset Counter Register */
N	volatile unsigned short dcfwindow;    /* DCFWINDOW    0x0037 1 [   :   ] Digital Compare Filter Window Register */
N	volatile unsigned short dcfwindowcnt; /* DCFWINDOWCNT 0x0038 1 [   :   ] Digital Compare Filter Window Counter Register */
N	volatile unsigned short dccap;        /* DCCAP        0x0039 1 [Yes:   ] Digital Compare Counter Capture Register */
N} PwmReg;
N
N
N/*** FUNCTION ***/
N
N/*** WORK ***/
Nstatic const unsigned short ch_addr[PWM_CH_NUM] =
Xstatic const unsigned short ch_addr[14] =
N{
N	PWM1_ADRS, PWM1_ADRS,
X	0x6800, 0x6800,
N	PWM2_ADRS, PWM2_ADRS,
X	0x6840, 0x6840,
N	PWM3_ADRS, PWM3_ADRS,
X	0x6880, 0x6880,
N	PWM4_ADRS, PWM4_ADRS,
X	0x68c0, 0x68c0,
N	PWM5_ADRS, PWM5_ADRS,
X	0x6900, 0x6900,
N	PWM6_ADRS, PWM6_ADRS,
X	0x6940, 0x6940,
N	PWM7_ADRS, PWM7_ADRS,
X	0x6980, 0x6980,
N};
N
Nstatic unsigned short st[PWM_CH_NUM];
Xstatic unsigned short st[14];
N
N#define	ST_INIT		0x0000
N#define	ST_CH_INIT	0x0001
N
N
N/*******************************************************************************
N *
N */
Nint pwm_init( void )
N{
N	int ch;
N
N
N	for( ch=0; ch<PWM_CH_NUM; ch++ ) {
X	for( ch=0; ch<14; ch++ ) {
N		st[ch] = ST_INIT;
X		st[ch] = 0x0000;
N	}
N
N	return 0;
N}
N
N/*******************************************************************************
N *
N */
Nint pwm_ch_init( int ch )
N{
N	int gpioNo;
N	PwmReg * pReg;
N	int chA, chB;
N
N	switch( ch ) {
N	case PWM_CH_1A:	/* GPIO0 */
X	case 0:	 
N	case PWM_CH_1B:	/* GPIO1 */
X	case 1:	 
N	case PWM_CH_2A:	/* GPIO2 */
X	case 2:	 
N	case PWM_CH_2B:	/* GPIO3 */
X	case 3:	 
N	case PWM_CH_3A:	/* GPIO4 */
X	case 4:	 
N	case PWM_CH_3B:	/* GPIO5 */
X	case 5:	 
N	case PWM_CH_4A:	/* GPIO6 */
X	case 6:	 
N	case PWM_CH_4B:	/* GPIO7 */
X	case 7:	 
N	case PWM_CH_5A:	/* GPIO8 */
X	case 8:	 
N	case PWM_CH_5B:	/* GPIO9 */
X	case 9:	 
N	case PWM_CH_6A:	/* GPIO10 */
X	case 10:	 
N	case PWM_CH_6B:	/* GPIO11 */
X	case 11:	 
N		gpioNo = ch;
N		break;
N	case PWM_CH_7A:	/* GPIO40 */
X	case 12:	 
N		gpioNo = 40;
N		break;
N	case PWM_CH_7B:	/* GPIO41 */
X	case 13:	 
N		gpioNo = 41;
N		break;
N	default :
N		return -1;
N	}
N
N	if( st[ch] != ST_INIT ) {
X	if( st[ch] != 0x0000 ) {
N		return -1;
N	}
N
N	chB = ch | 1;
N	chA = chB -1 ;
N
N	pReg = (PwmReg *)ch_addr[ch];
N
N	if( ((st[chA] | st[chB]) & ST_CH_INIT) == 0 ) {
X	if( ((st[chA] | st[chB]) & 0x0001) == 0 ) {
N		pReg->tbprd = TBPRD_VAL;
X		pReg->tbprd = 600;
N		pReg->cmpa = TBPRD_VAL/2;
X		pReg->cmpa = 600/2;
N		pReg->cmpb = TBPRD_VAL/2;
X		pReg->cmpb = 600/2;
N		pReg->tbphs = 0;
N		pReg->tbctr = 0;
N		pReg->tbctl = TBCTL_DIV_VAL
X		pReg->tbctl = ((0<<7)|(0<<10))
N		            | TBCTL_CTRMODE_UP
X		            | (0)
N//		            | TBCTL_PHSEN
N//		            | TBCTL_PRDLD
N		            | TBCTL_SYNCOSEL_DISABLE
X		            | (3<<4)
N		            ;
N		pReg->cmpctl = 0
N		             |CMPCTL_LOADAMODE_CTR_ZERO
X		             |(0<<2)
N		             |CMPCTL_LOADBMODE_CTR_ZERO
X		             |(0<<2)
N		             ;
N		pReg->aqctla = AQCTLx_CBD(AQCTLx_xxx_NOTHING)
X		pReg->aqctla = ((0)<<10)
N		             | AQCTLx_CBU(AQCTLx_xxx_NOTHING)
X		             | ((0)<<8)
N		             | AQCTLx_CAD(AQCTLx_xxx_NOTHING)
X		             | ((0)<<6)
N		             | AQCTLx_CAU(AQCTLx_xxx_CLEAR)
X		             | ((1)<<4)
N		             | AQCTLx_PRD(AQCTLx_xxx_NOTHING)
X		             | ((0)<<2)
N		             | AQCTLx_ZRO(AQCTLx_xxx_SET)
X		             | ( 2 )
N		             ;
N		pReg->aqctlb = AQCTLx_CBD(AQCTLx_xxx_NOTHING)
X		pReg->aqctlb = ((0)<<10)
N		             | AQCTLx_CBU(AQCTLx_xxx_CLEAR)
X		             | ((1)<<8)
N		             | AQCTLx_CAD(AQCTLx_xxx_NOTHING)
X		             | ((0)<<6)
N		             | AQCTLx_CAU(AQCTLx_xxx_NOTHING)
X		             | ((0)<<4)
N		             | AQCTLx_PRD(AQCTLx_xxx_NOTHING)
X		             | ((0)<<2)
N		             | AQCTLx_ZRO(AQCTLx_xxx_SET)
X		             | ( 2 )
N		             ;
N
N	}
N
N	st[ch] |= ST_CH_INIT;
X	st[ch] |= 0x0001;
N	pwm_duty( ch, 0 );
N
N	if( gpioConfig( gpioNo, GPIO_MODE_1 | GPIO_MODE_OUT ) ) {
X	if( gpioConfig( gpioNo, 0x002 | 0x020 ) ) {
N		return -1;
N	}
N
N
N	return 0;
N}
N
N/*******************************************************************************
N *
N */
Nint pwm_duty( int ch, float duty )
N{
N	int retVal;
N	unsigned short cmpVal;
N	PwmReg * pReg;
N
N	retVal = -1;
N
N	if( ch < PWM_CH_NUM ) {
X	if( ch < 14 ) {
N		if( st[ch] & ST_CH_INIT ) {
X		if( st[ch] & 0x0001 ) {
N
N			pReg = (PwmReg *)ch_addr[ch];
N
N			if( duty > 0.0 ) {
N				duty *= (float)TBPRD_VAL;
X				duty *= (float)600;
N				duty /= 100.0;
N				duty += 0.5;
N				cmpVal = (unsigned short)duty;
N				if( cmpVal >= TBPRD_VAL ) {
X				if( cmpVal >= 600 ) {
N					cmpVal = TBPRD_VAL;
X					cmpVal = 600;
N				}
N			} else {
N				cmpVal = 0;
N			}
N
N			if( ch & 1 ) {
N				/* B */
N				if( cmpVal == 0 ) {
N					pReg->aqctlb = AQCTLx_CBD(AQCTLx_xxx_NOTHING)
X					pReg->aqctlb = ((0)<<10)
N					             | AQCTLx_CBU(AQCTLx_xxx_NOTHING)
X					             | ((0)<<8)
N					             | AQCTLx_CAD(AQCTLx_xxx_NOTHING)
X					             | ((0)<<6)
N					             | AQCTLx_CAU(AQCTLx_xxx_NOTHING)
X					             | ((0)<<4)
N					             | AQCTLx_PRD(AQCTLx_xxx_NOTHING)
X					             | ((0)<<2)
N					             | AQCTLx_ZRO(AQCTLx_xxx_CLEAR)
X					             | ( 1 )
N					             ;
N				} else if( cmpVal == TBPRD_VAL ) {
X				} else if( cmpVal == 600 ) {
N					pReg->aqctlb = AQCTLx_CBD(AQCTLx_xxx_NOTHING)
X					pReg->aqctlb = ((0)<<10)
N					             | AQCTLx_CBU(AQCTLx_xxx_NOTHING)
X					             | ((0)<<8)
N					             | AQCTLx_CAD(AQCTLx_xxx_NOTHING)
X					             | ((0)<<6)
N					             | AQCTLx_CAU(AQCTLx_xxx_NOTHING)
X					             | ((0)<<4)
N					             | AQCTLx_PRD(AQCTLx_xxx_NOTHING)
X					             | ((0)<<2)
N					             | AQCTLx_ZRO(AQCTLx_xxx_SET)
X					             | ( 2 )
N					             ;
N				} else {
N					pReg->cmpb = cmpVal;
N					pReg->aqctlb = AQCTLx_CBD(AQCTLx_xxx_NOTHING)
X					pReg->aqctlb = ((0)<<10)
N					             | AQCTLx_CBU(AQCTLx_xxx_CLEAR)
X					             | ((1)<<8)
N					             | AQCTLx_CAD(AQCTLx_xxx_NOTHING)
X					             | ((0)<<6)
N					             | AQCTLx_CAU(AQCTLx_xxx_NOTHING)
X					             | ((0)<<4)
N					             | AQCTLx_PRD(AQCTLx_xxx_NOTHING)
X					             | ((0)<<2)
N					             | AQCTLx_ZRO(AQCTLx_xxx_SET)
X					             | ( 2 )
N					             ;
N				}
N			} else {
N				/* A */
N				if( cmpVal == 0 ) {
N					pReg->aqctla = AQCTLx_CBD(AQCTLx_xxx_NOTHING)
X					pReg->aqctla = ((0)<<10)
N					             | AQCTLx_CBU(AQCTLx_xxx_NOTHING)
X					             | ((0)<<8)
N					             | AQCTLx_CAD(AQCTLx_xxx_NOTHING)
X					             | ((0)<<6)
N					             | AQCTLx_CAU(AQCTLx_xxx_NOTHING)
X					             | ((0)<<4)
N					             | AQCTLx_PRD(AQCTLx_xxx_NOTHING)
X					             | ((0)<<2)
N					             | AQCTLx_ZRO(AQCTLx_xxx_CLEAR)
X					             | ( 1 )
N					             ;
N				} else if( cmpVal == TBPRD_VAL ) {
X				} else if( cmpVal == 600 ) {
N					pReg->aqctla = AQCTLx_CBD(AQCTLx_xxx_NOTHING)
X					pReg->aqctla = ((0)<<10)
N					             | AQCTLx_CBU(AQCTLx_xxx_NOTHING)
X					             | ((0)<<8)
N					             | AQCTLx_CAD(AQCTLx_xxx_NOTHING)
X					             | ((0)<<6)
N					             | AQCTLx_CAU(AQCTLx_xxx_NOTHING)
X					             | ((0)<<4)
N					             | AQCTLx_PRD(AQCTLx_xxx_NOTHING)
X					             | ((0)<<2)
N					             | AQCTLx_ZRO(AQCTLx_xxx_SET)
X					             | ( 2 )
N					             ;
N				} else {
N					pReg->cmpa = cmpVal;
N					pReg->aqctla = AQCTLx_CBD(AQCTLx_xxx_NOTHING)
X					pReg->aqctla = ((0)<<10)
N					             | AQCTLx_CBU(AQCTLx_xxx_NOTHING)
X					             | ((0)<<8)
N					             | AQCTLx_CAD(AQCTLx_xxx_NOTHING)
X					             | ((0)<<6)
N					             | AQCTLx_CAU(AQCTLx_xxx_CLEAR)
X					             | ((1)<<4)
N					             | AQCTLx_PRD(AQCTLx_xxx_NOTHING)
X					             | ((0)<<2)
N					             | AQCTLx_ZRO(AQCTLx_xxx_SET)
X					             | ( 2 )
N					             ;
N				}
N			}
N			retVal = 0;
N		}
N	}
N
N	return retVal;
N}
N
N/*** end of file : pwmDrv.c ***/
