L 1 "../src/bsp/tms320f28035/sciDrv.c"
N/*** sciDrv.c - TMS320F28035 (piccolo) SCI Driver ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/15 mimu
N              First Version
N */
N
N/*** NOTE ***
N *
N *** ATTATION ***
N * 1) This driver support Channel A (channel 0) only
N *
N *** Register map ***
N * --- A Channel ---
N * SCICCR   0x0000-7050 1 SCI-A Communications Control Register
N * SCICTL1  0x0000-7051 1 SCI-A Control Register 1
N * SCIHBAUD 0x0000-7052 1 SCI-A Baud Register, High Bits
N * SCILBAUD 0x0000-7053 1 SCI-A Baud Register, Low Bits
N * SCICTL2  0x0000-7054 1 SCI-A Control Register 2
N * SCIRXST  0x0000-7055 1 SCI-A Receive Status Register
N * SCIRXEMU 0x0000-7056 1 SCI-A Receive Emulation Data Buffer Register
N * SCIRXBUF 0x0000-7057 1 SCI-A Receive Data Buffer Register
N
N * SCITXBUF 0x0000-7059 1 SCI-A Transmit Data Buffer Register
N * SCIFFTX  0x0000-705A 1 SCI-A FIFO Transmit Register
N * SCIFFRX  0x0000-705B 1 SCI-A FIFO Receive Register
N * SCIFFCT  0x0000-705C 1 SCI-A FIFO Control Register
N
N * SCIPRI   0x0000-705F 1 SCI-A Priority Control Register
N */
N
N/*** INCLUDE ***/
N#include "config.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/bsp/config.h" 1
N/*** config.h ***/
N
N
N#ifndef	INC_config_H
N#define	INC_config_H
N
N/******************************************************************************/
N/* NvRam Configuration                                                        */
N/******************************************************************************/
N#define	FLASH_PROGRAM_SEC_NO		0
N#define	FLASH_PROGRAM_SEC_NUM		6
N
N#define	FLASH_BOOTLOADER_SEC_NO		(FLASH_PROGRAM_SEC_NO + FLASH_PROGRAM_SEC_NUM)
N#define	FLASH_BOOTLOADER_SEC_NUM	2
N
N/******************************************************************************/
N/* Driver Configuration                                                       */
N/******************************************************************************/
N
N/*** CPU TIMER ***/
N#define	SUPPORT_CPU_TIMER_0		/* !! ATTATION !! system need timer0 */
N//#define	SUPPORT_CPU_TIMER_1
N//#define	SUPPORT_CPU_TIMER_2
N
N/*** SCI ***/
N#define	SUPPORT_SCI_A
N
N/*** Flash Mem. ***/
N//#define	SUPPORT_FLASH
N
N/******************************************************************************/
N/* GPIO map                                                                   */
N/******************************************************************************/
N#define	GPIO_NO_CPU_LED	39
N
N//#define	GPIO_NO_SCIRXDA	7
N#define	GPIO_NO_SCIRXDA	28
N
N//#define	GPIO_NO_SCITXDA	12
N#define	GPIO_NO_SCITXDA	29
N
N
N/*-----------------------------------------------------------------------------
N      Specify the PLL control register (PLLCR) and divide select (DIVSEL) value.
N-----------------------------------------------------------------------------*/
N
N//#define DSP28_DIVSEL   0 // Enable /4 for SYSCLKOUT
N//#define DSP28_DIVSEL   1 // Disable /4 for SYSCKOUT
N#define DSP28_DIVSEL   2 // Enable /2 for SYSCLKOUT
N//#define DSP28_DIVSEL   3 // Enable /1 for SYSCLKOUT
N
N
N#define DSP28_PLLCR   12    // Uncomment for 60 MHz devices [60 MHz = (10MHz * 12)/2]
N//#define DSP28_PLLCR   11
N//#define DSP28_PLLCR   10
N//#define DSP28_PLLCR    9
N//#define DSP28_PLLCR    8      // Uncomment for 40 MHz devices [40 MHz = (10MHz * 8)/2]
N//#define DSP28_PLLCR    7
N//#define DSP28_PLLCR    6
N//#define DSP28_PLLCR    5
N//#define DSP28_PLLCR    4
N//#define DSP28_PLLCR    3
N//#define DSP28_PLLCR    2
N//#define DSP28_PLLCR    1
N//#define DSP28_PLLCR    0  // PLL is bypassed in this mode
N//----------------------------------------------------------------------------
N
N/*-----------------------------------------------------------------------------
N      Specify the clock rate of the CPU (SYSCLKOUT) in nS.
N
N      Take into account the input clock frequency and the PLL multiplier
N      selected in step 1.
N
N      Use one of the values provided, or define your own.
N      The trailing L is required tells the compiler to treat
N      the number as a 64-bit value.
N
N      Only one statement should be uncommented.
N
N      Example:   60 MHz devices:
N                 CLKIN is a 10 MHz crystal or internal 10 MHz oscillator
N
N                 In step 1 the user specified PLLCR = 0xC for a
N                 60 MHz CPU clock (SYSCLKOUT = 60 MHz).
N
N                 In this case, the CPU_RATE will be 16.667L
N                 Uncomment the line: #define CPU_RATE 16.667L
N
N-----------------------------------------------------------------------------*/
N
N#define CPU_RATE   16.667L   // for a 60MHz CPU clock speed (SYSCLKOUT)
N//#define CPU_RATE   20.000L   // for a 50MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   25.000L   // for a 40MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   33.333L   // for a 30MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   41.667L   // for a 24MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   50.000L   // for a 20MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   66.667L   // for a 15MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE  100.000L   // for a 10MHz CPU clock speed  (SYSCLKOUT)
N
N#if 0
S//----------------------------------------------------------------------------
S
S// The following pointer to a function call calibrates the ADC and internal oscillators
S#define Device_cal (void   (*)(void))0x3D7C80
S
S//---------------------------------------------------------------------------
S// Include Example Header Files:
S//
S
S#include "DSP2803x_GlobalPrototypes.h"         // Prototypes for global functions within the
S                                               // .c files.
S#include "DSP2803x_EPwm_defines.h"             // Macros used for PWM examples.
S#include "DSP2803x_I2C_defines.h"              // Macros used for I2C examples.
S#include "DSP2803x_Cla_Defines.h"              // Macros used for CLA examples.
S
S
S#define   PARTNO_28030PAG   0xAA
S#define   PARTNO_28030PN    0xAB
S
S#define   PARTNO_28031PAG   0xAE
S#define   PARTNO_28031PN    0xAF
S
S#define   PARTNO_28032PAG   0xB2
S#define   PARTNO_28032PN    0xB3
S
S#define   PARTNO_28033PAG   0xB6
S#define   PARTNO_28033PN    0xB7
S
S#define   PARTNO_28034PAG   0xBA
S#define   PARTNO_28034PN    0xBB
S
S#define   PARTNO_28035PAG   0xBE
S#define   PARTNO_28035PN    0xBF
S
S// Include files not used with DSP/BIOS
S#ifndef DSP28_BIOS
S#include "DSP2803x_DefaultISR.h"
S#endif
N#endif
N
Nextern void DSP28x_usDelay(unsigned long Count);
N// DO NOT MODIFY THIS LINE.
N#define DELAY_US(A)  DSP28x_usDelay(((((long double) A * 1000.0L) / (long double)CPU_RATE) - 9.0L) / 5.0L)
N
N#endif	/* INC_config_H */
N
N/*** end of file : config.h ***/
L 36 "../src/bsp/tms320f28035/sciDrv.c" 2
N#include "sysLib.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/bsp/sysLib.h" 1
N/*** sysLib.h - system i/f header ***/
N
N/*** Copyright(C) 2008 mimu ***/
N
N/*** NOTE ***
N */
N
N/*** HISTORY ***
N * 2007/08/xx mimu@emb
N              First version for SH-4A
N */
N
N#ifndef	INC_sysLib_H
N#define	INC_sysLib_H
N
N#ifndef	_ASMLANGUAGE
N
N#include	"config.h"
N
N//#include	"kernel.h"
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
N
Nint sysInit( void );
N
Nvoid sysDummyFunc();
Nvoid sysHalt( const char * msg );
N
N/* interrupt mask */
Nint		sysIntLock( void );
Nvoid	sysIntUnlock( int );
N
Nvoid bspDelay100nSec( int count );
N
Nconst char * sysOptionStringSerch( const char * pOpt, int *pLen, char startcode );
N
N/* for interrupt */
Nint sysIntConnect( unsigned int vecNo, void (*pFunc)(unsigned int vecNo) );
Nint sysIntEnable( unsigned int vecNo );
Nint sysIntDisable( unsigned int vecNo );
N
N//void * sysAlloc( unsigned long size, unsigned long aligne, int bDma );
N
N//extern void cachePurge( void * p, unsigned long size);	/* this function defined in romInit.src */
N
N/*** for NV-RAM ***/
N
N#if 0
S//int sysNvRamInit( void );
S//
S//int	sysNvRamMacGet( int ch, unsigned char * pMac );
S//int sysNvRamMacSet( int ch, unsigned char * pMac );
S//
S//int sysNvRamNetGet( int ch, SysNetCfg * pNet );
S//int sysNvRamNetSet( int ch, SysNetCfg * pNet );
S//
S//int sysNvRamExceptionGet( SysException * pSysException );
S//
S//int sysNvRamConsoleBpsGet( void );
S//int sysNvRamConsoleBpsSet( int bps );
S//
S//int sysNvRamPasswordGet( unsigned char * password );
S//int sysNvRamPasswordSet( unsigned char * password, int len );
S//
S//int sysNvRamLcdContrastGet( void );
S//int sysNvRamLcdContrastSet( int contrast );
N#endif
N
N#if 0	/* move to sysNvRam.h */
Sint	sysNvRamMacGet( int ch, unsigned char * );
Sint sysNvRamMacSet( int ch, unsigned char * );
N#endif
N
N#ifdef	__cplusplus
S}
N#endif
N
N#endif	/* _ASMLANGUAGE */
N#endif	/* INC_sysLib_H */
N
N/*** end of file : sysLib.h ***/
L 37 "../src/bsp/tms320f28035/sciDrv.c" 2
N
N#include "gpioDrv.h"
L 1 "..\src\bsp\tms320f28035\gpioDrv.h" 1
N/*** gpioDrv.h - TMS320F28035(piccolo) GPIO driver ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/09 mimu
N              First Version
N */
N
N#ifndef	INC_gpioDrv_H
N#define	INC_gpioDrv_H
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
N#define	GPIO_MAX	44
N#define	GPIO_NUM	45
N
Nint gpioInit( void );
Nint gpioConfig( int no, int mode );
N#define	GPIO_MODE_GPIO			0x001
N#define	GPIO_MODE_1				0x002
N#define	GPIO_MODE_2				0x004
N#define	GPIO_MODE_3				0x008
N
N#define	GPIO_MODE_IN			0x010
N#define	GPIO_MODE_OUT			0x020
N#define	GPIO_MODE_PULLUP_DIS	0x040
N#define	GPIO_MODE_PULLUP		0x080
N
N#define	GPIO_MODE_QUALIFIER_0	0x100
N#define	GPIO_MODE_QUALIFIER_1	0x200
N#define	GPIO_MODE_QUALIFIER_2	0x400
N#define	GPIO_MODE_QUALIFIER_3	0x800
N#define	GPIO_MODE_QUALIFILER(_x)	(0x100<<(_x))&0x0f00))
N
N#define	GPIO_CTRL_SET		0
N#define	GPIO_CTRL_CLR		1
N#define	GPIO_CTRL_TOGGLE	2
N#define	GPIO_CTRL_GET		3
Nint gpioCtrl( int no, int ctrl );
N
N//int gpioControl( int no, int bHigh );
N#define	gpioControl( _no, _bH )	(bH?gpioCtrl(_no, GPIO_CTRL_SET):gpioCtrl(_no, GPIO_CTRL_CLR))
N//int gpioSet( int no );
N#define	gpioSet( _no )		gpioCtrl( _no, GPIO_CTRL_SET )
N//int gpioClear( int no );
N#define	gpioClear( _no )	gpioCtrl( _no, GPIO_CTRL_CLR )
N//int gpioToggle( int no );
N#define	gpioToggle( _no )	gpioCtrl( _no, GPIO_CTRL_TOGGLE )
N//int gpioGet( int no );
N#define	gpioGet( _no )		gpioCtrl( _no, GPIO_CTRL_GET )
N
Nint gpioCtrlRegSet( int reg, int value );
N#define	GPIO_CTRLREG_QUALPRD_0_7	0		/* GPIO 0-7 */
N#define	GPIO_CTRLREG_QUALPRD_8_15	1		/* GPIO 8-15 */
N#define	GPIO_CTRLREG_QUALPRD_16_23	2		/* GPIO 16-23 */
N#define	GPIO_CTRLREG_QUALPRD_24_31	3		/* GPIO 24-31 */
N
N#define	GPIO_CTRLREG_QUBLPRD_32_39	4		/* GPIO 32-39 */
N#define	GPIO_CTRLREG_QUBLPRD_40_44	5		/* GPIO 32-44 */
N
N#ifdef	__cplusplus
S} /* extern "C" */
N#endif
N
N#endif	/* INC_gpioDrv_H */
N
N/*** end of file : gpioDrv.h ***/
L 39 "../src/bsp/tms320f28035/sciDrv.c" 2
N#include "lib/ringLib.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/bsp/lib/ringLib.h" 1
N/*** ringLib.c - Ring Buffer Manager ***/
N
N/*** Copyright(C) 1989-2011 Kazuya Mimura ***/
N/*** Copyrigth(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/16 mimu
N              Clean-up & remodify
N * 1989/07/xx mimu
N              First Version
N */
N
N#ifndef	INC_ringLib_H
N#define	INC_ringLib_H
N
Ntypedef	struct ring_t {
N	unsigned char * pDataTop;
N	int				size;
N
N	unsigned char * pGet;
N	unsigned char * pSetNext;
N	unsigned char * pDataBotom;
N} Ring;
N
Nint ringInit( Ring * pRing );
Nint ringSet( Ring * pRing, unsigned char * pData, int size );
Nint ringGet( Ring * pRing, unsigned char * pData, int size );
Nvoid ringFlush( Ring * pRing );
Nint ringSize( Ring * pRing );
Nunsigned char ringPeek( Ring * pRing );
N
N#endif	/* INC_ringLib_H */
N/*** end of file : ringLib.c ***/
L 40 "../src/bsp/tms320f28035/sciDrv.c" 2
N#include "sciDrv.h"
L 1 "..\src\bsp\tms320f28035\sciDrv.h" 1
N/*** sciDrv.h - TMS320F28035 (piccolo) SCI Driver ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/15 mimu
N              First Version
N */
N
N#ifndef	INC_sciDrv_H
N#define	INC_sciDrv_H
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
Nint sciDrvInit( unsigned long _baseClock );
Nint sciCtrl( unsigned long bps, int charLen, char parity, int stop );
Nint sciOpen( void );
Nint sciClose( void );
Nint sciTx( unsigned char * pData, int len, int lenMin );
Nint sciRx( unsigned char * pData, int len, int lenMin );
N
Nint sciRxSize( void );
Nint sciRxPeek( void );
Nvoid sciRxFlush( void );
N
N
N#ifdef	__cplusplus
S} /* extern "C" */
N#endif
N
N#endif	/* INC_sciDrv_H */
N
N/*** end of file : sciDrv.h ***/
L 41 "../src/bsp/tms320f28035/sciDrv.c" 2
N
N
N/*** DEFINE ***/
N#define	TX_BUFF_SIZE	32
N#define	RX_BUFF_SIZE	64
N
N#define	DEFAULT_BPS		9600UL
N#define	DEFAULT_CHARLEN	8
N#define	DEFAULT_STOP	1
N#define	DEFAULT_PARITY	'N'
N
N#define	TX_FIFO_LVL		1
N#define	RX_FIFO_LVL		1
N
N#define	TX_FIFO_NUM		4
N#define	RX_FIFO_NUM		4
N
N#ifndef	SUPPORT_SCI_A
S#error
N#endif
N
N#ifndef	GPIO_NO_SCIRXDA
S#error
N#endif
N
N#ifndef	GPIO_NO_SCITXDA
S#error
N#endif
N
Ntypedef struct sci_reg_t {
N/** **/
N	volatile unsigned short	ccr;	/* Communications Control			*/
N#	define	CCR_STOP_BITS_1	(0<<7)
N#	define	CCR_STOP_BITS_2	(1<<7)
N
N#	define	_CCR_EVEN_PARITY	(1<<6)
N#	define	_CCR_ODD_PARITY	(0<<6)
N#	define	_CCR_PARITY_ENABLE	(1<<5)
N#	define	CCR_PARITY_EVEN		(_CCR_PARITY_ENABLE|_CCR_EVEN_PARITY)
N#	define	CCR_PARITY_ODD		(_CCR_PARITY_ENABLE|_CCR_ODD_PARITY)
N#	define	CCR_PARITY_NONE		0
N
N#	define	CCR_LOOPBACK_ENA	(1<<4)
N
N									/* ADDR/IDLE MODE SCI multiprocessor mode control bit */
N#	define	CCR_ADDR_MODE		(1<<3)
N#	define	CCR_IDLE_MODE		(0<<3)
N
N#	define	CCR_CHAR(_len)		((_len)-1)	/* 1<=_len<=8 */
N
N/** **/
N	volatile unsigned short	ctl1;	/* Control 1						*/
N#	define	CTL1_RX_ERRINT_ENA	(1<<6)
N//#	define	CTL1_SW_RESET		(1<<5)
N#	define	CTL1_SCI_RUN		(1<<5)
N#	define	CTL1_TXWAKE			(1<<3)
N#	define	CTL1_SLEEP			(1<<2)
N
N#	define	CTL1_TXENA			(1<<1)
N#	define	CTL1_RXENA			(1<<0)
N
N
N	volatile unsigned short	hbaud;	/* Baud High Bits					*/
N	volatile unsigned short	baud;	/* Baud Low Bits					*/
N	volatile unsigned short	ctl2;	/* Control 2						*/
N#	define	CTL2_TXRDY		(1<<7)
N#	define	CTL2_TXEMPTY	(1<<6)
N#	define	CTL2_RXINT_ENA	(1<<1)
N#	define	CTL2_TXINT_ENA	(1<<0)
N
N	volatile unsigned short	rxst;	/* Receive Status					*/
N#	define	RXST_RXERROR	(1<<7)
N#	define	RXST_RXRDY		(1<<6)
N#	define	RXST_BRKDT		(1<<5)
N#	define	RXST_FE			(1<<4)
N#	define	RXST_OE			(1<<3)
N#	define	RXST_PE			(1<<2)
N#	define	RXST_RXWAKE		(1<<1)
N
N	volatile unsigned short	rxemu;	/* Receive Emulation Data Buffer	*/
N	volatile unsigned short	rxbuf;	/* Receive Data Buffer				*/
N#	define	RXBUF_SCIFFFE	(1<<15)
N#	define	RXBUF_SCIFFPE	(1<<14)
N#	define	RXBUF_RXDT		(0xff)
N
N	         unsigned short __dummy__0;
N
N	volatile unsigned short	txbuf;	/* Transmit Data Buffer				*/
N	volatile unsigned short	fftx;	/* FIFO Transmit					*/
N//#define	FFTX_SCIRST		(1<<15)
N#define	FFTX_SCIRUN			(1<<15)
N#define	FFTX_SCIFFENA	(1<<14)
N//#define	FFTX_TXFIFO_RESET	(1<<13)
N#define	FFTX_TXFIFO_ENABLE	(1<<13)
N#define	FFTX_TXFFST(_reg)	(((_reg)>>8)&0x01f)
N#define	FFTX_TXFFINT_FLAG	(1<<7)
N#define	FFTX_TXFFINT_CLR	(1<<6)
N#define	FFTX_TXFFIENA		(1<<5)
N#define	FFTX_TXFFIL(_lvl)	((_lvl)&0x1f)
N
N	volatile unsigned short	ffrx;	/* FIFO Receive						*/
N#define	FFRX_RXFFOVF		(1<<15)
N#define	FFRX_RXFFOVF_CLR	(1<<14)
N//#define	FFRX_RXFIFO_RESET	(1<<13)
N#define	FFRX_RXFIFO_ENABLE	(1<<13)
N#define	FFRX_RXFFST(_reg)	(((_reg)>>8)&0x01f)
N#define	FFRX_RXFFINT		(1<<7)
N#define	FFRX_RXFFINT_CLR	(1<<6)
N#define	FFRX_RXFFIENA		(1<<5)
N#define	FFRX_RXFFIL(_lvl)	((_lvl)&0x1f)
N
N	volatile unsigned short	ffct;	/* FIFO Control						*/
N#define	FFCT_ABD			(1<<15)
N#define	FFCT_ABD_CLR		(1<<14)
N#define	FFCT_CDC			(1<<13)
N#define	FFCT_FFTXDLY(_dly)	((_dly)&0x0ff)
N
N	         unsigned short __dummy__1;
N
N	volatile unsigned short	pri;	/* Priority Control					*/
N#define	PRI_SOFT		(1<<4)
N#define	PRI_FREE		(1<<3)
N
N} SciReg;
N
Ntypedef struct sci_chan_t {
N	int			st;
N#define	ST_INIT		(1<<0)
N#define	ST_CONFIG	(1<<1)
N#define	ST_OPEN		(1<<2)
N
N	SciReg *	pReg;
N
N	unsigned long	bps;
N	int				charLen;
N	int				stop;
N	char			parity;
N
N//	IntID		rxIntID;
N//	IntID		txIntID;
N	unsigned int	vecNo_rx;
N	unsigned int	vecNo_tx;
N
N	Ring txRing;
N	Ring rxRing;
N
N	unsigned char txBuff[TX_BUFF_SIZE];
X	unsigned char txBuff[32];
N	unsigned char rxBuff[RX_BUFF_SIZE];
X	unsigned char rxBuff[64];
N
N
N} SciChan;
N
N/*** FUNCTION ***/
Nstatic int sciConfig( SciChan * pChan );
Nstatic void sciIntTx( unsigned int vecNo );
Nstatic void sciIntRx( unsigned int vecNo );
N
N/*** WORK ***/
Nstatic unsigned long baseClock;
Nstatic SciChan sciChan;
N
N/*******************************************************************************
N *
N */
Nint sciDrvInit( unsigned long _baseClock )
N{
N	SciReg * pReg;
N
N
N	if( _baseClock == 0 ) {
N		return -1;
N	}
N
N	/*
N	 * Configuration GPIO for SCI
N	 */
N	{
N		int mode;
N		mode = GPIO_MODE_IN
X		mode = 0x010
N		     | GPIO_MODE_PULLUP
X		     | 0x080
N#if	(GPIO_NO_SCIRXDA==7)
X#if	(28==7)
S		     | GPIO_MODE_2;
N#elif (GPIO_NO_SCIRXDA==28)
X#elif (28==28)
N		     | GPIO_MODE_1;
X		     | 0x002;
N#else
S#error
N#endif
N		if( gpioConfig( GPIO_NO_SCIRXDA, mode ) ) {
X		if( gpioConfig( 28, mode ) ) {
N			return -1;
N		}
N
N		mode = GPIO_MODE_OUT
X		mode = 0x020
N		     | GPIO_MODE_PULLUP
X		     | 0x080
N#if (GPIO_NO_SCITXDA==12)
X#if (29==12)
S		     | GPIO_MODE_2;
N#elif (GPIO_NO_SCITXDA==29)
X#elif (29==29)
N		     | GPIO_MODE_1;
X		     | 0x002;
N#else
S#error
N#endif
N
N		if( gpioConfig( GPIO_NO_SCITXDA, mode ) ) {
X		if( gpioConfig( 29, mode ) ) {
N			return -1;
N		}
N	}
N
N	baseClock = _baseClock;
N
N	pReg = (SciReg *)0x7050;
N//	sciChan.rxIntID = IntID_SciA_RX;
N//	sciChan.txIntID = IntID_SciA_TX;
N	sciChan.vecNo_rx = 96;
N	sciChan.vecNo_tx = 97;
N
N	sciChan.txRing.pDataTop = &sciChan.txBuff[0];
N	sciChan.txRing.size     = TX_BUFF_SIZE;
X	sciChan.txRing.size     = 32;
N	if( ringInit( &sciChan.txRing ) ) {
N		return -1;
N	}
N
N	sciChan.rxRing.pDataTop = &sciChan.rxBuff[0];
N	sciChan.rxRing.size     = RX_BUFF_SIZE;
X	sciChan.rxRing.size     = 64;
N	if( ringInit( &sciChan.rxRing ) ) {
N		return -1;
N	}
N
N	sciChan.pReg    = pReg;
N	sciChan.bps     = DEFAULT_BPS;
X	sciChan.bps     = 9600UL;
N	sciChan.charLen = DEFAULT_CHARLEN;
X	sciChan.charLen = 8;
N	sciChan.stop    = DEFAULT_STOP;
X	sciChan.stop    = 1;
N	sciChan.parity  = DEFAULT_PARITY;
X	sciChan.parity  = 'N';
N
N	sciChan.st = ST_INIT;
X	sciChan.st = (1<<0);
N
N	pReg->ctl1 = 0;	/* force reset */
N
N	if( sysIntConnect( sciChan.vecNo_rx, sciIntRx ) ) {
N		return -1;
N	}
N//	if( sysIntEnable( sciChan.rxIntID ) ) {
N//		return -1;
N//	}
N
N	if( sysIntConnect( sciChan.vecNo_tx, sciIntTx ) ) {
N		return -1;
N	}
N//	if( sysIntEnable( sciChan.txIntID ) ) {
N//		return -1;
N//	}
N
N	if( sciConfig( &sciChan ) ) {
N		return -1;
N	}
N
N	return 0;
N}
N
N/*******************************************************************************
N *
N */
Nstatic int sciConfig( SciChan * pChan )
N{
N	SciReg * pReg;
N
N	unsigned short ccrVal;
N	unsigned long brrVal;
N	unsigned short ffctVal;
N
N	if( pChan->st & ST_OPEN ) {
X	if( pChan->st & (1<<2) ) {
N		return -1;
N	}
N
N	pChan->st &= ~ST_CONFIG;
X	pChan->st &= ~(1<<1);
N
N	ccrVal = 0;
N	ffctVal = FFCT_ABD_CLR;
X	ffctVal = (1<<14);
N
N	switch( pChan->stop ) {
N	case 1: ccrVal |= CCR_STOP_BITS_1; ffctVal = FFCT_FFTXDLY(0); break;
X	case 1: ccrVal |= (0<<7); ffctVal = ((0)&0x0ff); break;
N	case 2: ccrVal |= CCR_STOP_BITS_2; ffctVal = FFCT_FFTXDLY(1); break;
X	case 2: ccrVal |= (1<<7); ffctVal = ((1)&0x0ff); break;
N	default: return -1; /* break; */
N	}
N
N	switch( pChan->parity ) {
N	case 'N': ccrVal |= CCR_PARITY_NONE; break;
X	case 'N': ccrVal |= 0; break;
N	case 'E': ccrVal |= CCR_PARITY_EVEN; break;
X	case 'E': ccrVal |= ((1<<5)|(1<<6)); break;
N	case 'O': ccrVal |= CCR_PARITY_ODD;  break;
X	case 'O': ccrVal |= ((1<<5)|(0<<6));  break;
N	default: return -1; /* break; */
N	}
N
N	switch( pChan->charLen ) {
N	case 1:
N	case 2:
N	case 3:
N	case 4:
N	case 5:
N	case 6:
N	case 7:
N	case 8:
N		ccrVal |= CCR_CHAR(pChan->charLen);
X		ccrVal |= ((pChan->charLen)-1);
N		break;
N	default:
N		return -1;
N		/* break; */
N	}
N
N	{
N//		unsigned long brr;
N		unsigned long clk;
N		unsigned long bps;
N		unsigned long bps16[3];
N		unsigned long d;
N		unsigned long dMin;
N		int i;
N		int iMin;
N
N		brrVal = ( baseClock/(pChan->bps * 8) ) - 1;
N		if( (brrVal==0) || (0x0fffe<brrVal) ) {
N			return -1;
N		}
N		clk = baseClock * 2;
N
N		bps16[0] = clk/brrVal;
N		bps16[1] = clk/(brrVal+1);
N		bps16[2] = clk/(brrVal+2);
N
N		bps = pChan->bps * 16;
N
N		dMin = 0x7fffffff;
N		iMin = -1;
N		for( i=0; i<3; i++ ) {
N			if( bps16[i] > bps ) {
N				d = bps16[i] - bps;
N			} else {
N				d = bps - bps16[i];
N			}
N			if( d <= dMin ) {
N				dMin = d;
N				iMin = i;
N			}
N		}
N
N		if( iMin < 0 ) {
N			return -1;
N		}
N
N		brrVal += iMin;
N		brrVal --;
N	}
N
N/// fftx <- e040  FFTX_SCIRUN | FFTX_SCIFFENA | FFTX_TXFIFO_ENABLE | FFTX_TXFFINT_CLR | FFTX_TXFFIL(0)
N/// ffrx <- 2044  FFRX_RXFIFO_ENABLE | FFRX_RXFFINT_CLR | FFRX_RXFFIL(4)
N/// ffct <- 0000
N	pReg = pChan->pReg;
N
N	pReg->ctl1 = 0;				/* force reset */
N	pReg->ctl1 = CTL1_SCI_RUN;	/* device run, but Tx & Rx Stoped */
X	pReg->ctl1 = (1<<5);	 
N
N//	pReg->fftx = FFTX_TXFFINT_CLR;	/* force reset (TxFIFO), clear Interrut Flag */
N//	pReg->fftx = FFTX_SCIRUN | FFTX_SCIFFENA | FFTX_TXFIFO_ENABLE | FFTX_TXFFIENA | FFTX_TXFFIL(TX_FIFO_LVL);
N	pReg->fftx = FFTX_SCIRUN | FFTX_SCIFFENA | FFTX_TXFIFO_ENABLE | FFTX_TXFFIENA | FFTX_TXFFINT_CLR | FFTX_TXFFIL(TX_FIFO_LVL);
X	pReg->fftx = (1<<15) | (1<<14) | (1<<13) | (1<<5) | (1<<6) | ((1)&0x1f);
N
N//	pReg->ffrx = FFRX_RXFFINT_CLR | FFRX_RXFFOVF_CLR;				/* force reset (RxFIFO) */
N//	pReg->ffrx = FFRX_RXFIFO_ENABLE | FFRX_RXFFIL(RX_FIFO_LVL);
N	pReg->ffrx = FFRX_RXFIFO_ENABLE | FFRX_RXFFINT_CLR | FFRX_RXFFIENA | FFRX_RXFFOVF_CLR | FFRX_RXFFIL(RX_FIFO_LVL);
X	pReg->ffrx = (1<<13) | (1<<6) | (1<<5) | (1<<14) | ((1)&0x1f);
N
N	pReg->ffct = ffctVal;
N
N	pReg->pri = PRI_FREE;
X	pReg->pri = (1<<3);
N
N	pReg->ccr = ccrVal;
N	pReg->hbaud = (unsigned short)( (brrVal >> 8) & 0xff );
N	pReg->baud  = (unsigned short)( brrVal & 0xff );
N
N//	pReg->ctl2 = CTL2_RXINT_ENA | CTL2_TXINT_ENA;
N
N//	pReg->ctl1 = CTL1_SCI_RUN | CTL1_TXENA | CTL1_RXENA;
N
N	pChan->st |= ST_CONFIG;
X	pChan->st |= (1<<1);
N
N	return 0;
N}
N
N/*******************************************************************************
N *
N */
Nint sciCtrl( unsigned long bps, int charLen, char parity, int stop )
N{
N	int retVal = -1;
N
N	if( (sciChan.st & (ST_INIT|ST_OPEN)) == ST_INIT ) {
X	if( (sciChan.st & ((1<<0)|(1<<2))) == (1<<0) ) {
N		sciChan.bps = bps;
N		sciChan.charLen = charLen;
N		sciChan.parity = parity;
N		sciChan.stop = stop;
N
N		retVal = sciConfig( &sciChan );
N	}
N
N	return retVal;
N}
N
N/*******************************************************************************
N *
N */
Nint sciOpen( void )
N{
N	int retVal = -1;
N
N	if( (sciChan.st & (ST_INIT|ST_CONFIG|ST_OPEN)) == (ST_INIT|ST_CONFIG) ) {
X	if( (sciChan.st & ((1<<0)|(1<<1)|(1<<2))) == ((1<<0)|(1<<1)) ) {
N		sciChan.st |= ST_OPEN;
X		sciChan.st |= (1<<2);
N
N		sciChan.pReg->ctl2 = CTL2_RXINT_ENA | CTL2_TXINT_ENA;
X		sciChan.pReg->ctl2 = (1<<1) | (1<<0);
N		sciChan.pReg->ctl1 = CTL1_SCI_RUN | CTL1_TXENA | CTL1_RXENA;
X		sciChan.pReg->ctl1 = (1<<5) | (1<<1) | (1<<0);
N		sysIntEnable( sciChan.vecNo_rx );
N		retVal = 0;
N	}
N
N	return retVal;
N}
N
N/*******************************************************************************
N *
N */
Nint sciClose( void )
N{
N	int retVal = -1;
N
N	if( sciChan.st == (ST_INIT|ST_CONFIG|ST_OPEN) ) {
X	if( sciChan.st == ((1<<0)|(1<<1)|(1<<2)) ) {
N		sciChan.st = ST_INIT | ST_CONFIG;
X		sciChan.st = (1<<0) | (1<<1);
N		sciChan.pReg->ctl2 = CTL2_RXINT_ENA | CTL2_TXINT_ENA;
X		sciChan.pReg->ctl2 = (1<<1) | (1<<0);
N		sciChan.pReg->ctl1 = CTL1_SCI_RUN | CTL1_TXENA;
X		sciChan.pReg->ctl1 = (1<<5) | (1<<1);
N		retVal = 0;
N	}
N
N	return retVal;
N}
N
N/*******************************************************************************
N *
N */
Nint sciTx( unsigned char * pData, int len, int lenMin )
N{
N	int retVal;
N	int setNum;
N
N	retVal = 0;
N
N	for( ; len > 0; ) {
N		/* push to buffer */
N		setNum = ringSet( &sciChan.txRing, pData, len );
N		if( setNum < 0 ) {
N			return -1;
N		}
N
N		retVal += setNum;
N		pData += setNum;
N		len -= setNum;
N		lenMin -= setNum;
N
N		/* kick transmitter */
N		sysIntEnable( sciChan.vecNo_tx );
N
N		if( setNum == 0 ) {
N			if( lenMin <= 0 ) {
N				return retVal;
N			}
N		}
N	}
N
N	return retVal;
N}
N
N/*******************************************************************************
N *
N */
Nstatic void sciIntTx( unsigned int vecNo )
N{
N	SciChan * pChan;
N	SciReg  * pReg;
N
N	unsigned char txBuff[TX_FIFO_NUM];
X	unsigned char txBuff[4];
N	unsigned short fftxVal;
N	int txByte;
N	int i;
N
N//	pChan = (SciChan *)arg;
N	pChan = &sciChan;
N	pReg = pChan->pReg;
N
N	fftxVal = pReg->fftx;
N	txByte = TX_FIFO_NUM - FFTX_TXFFST(fftxVal);
X	txByte = 4 - (((fftxVal)>>8)&0x01f);
N
N	txByte = ringGet( &pChan->txRing, &txBuff[0], txByte );
N
N	if( txByte > 0 ) {
N		for( i=0; i<txByte; i++ ) {
N			pReg->txbuf = (unsigned short)txBuff[i];
N		}
N//		pReg->fftx |= FFTX_TXFFINT_CLR;
N	} else {
N		sysIntDisable( pChan->vecNo_tx );
N	}
N	pReg->fftx |= FFTX_TXFFINT_CLR;
X	pReg->fftx |= (1<<6);
N}
N
N/*******************************************************************************
N *
N */
Nvoid sciRxFlush( void )
N{
N	ringFlush( &sciChan.rxRing );
N}
N
N
N/*******************************************************************************
N *
N */
Nint sciRxSize( void )
N{
N	return ringSize( &sciChan.rxRing );
N}
N
N/*******************************************************************************
N *
N */
Nint sciRxPeek( void )
N{
N	unsigned char data;
N
N	data = ringPeek( &sciChan.rxRing );
N
N	return (int)data;
N}
N
N/*******************************************************************************
N *
N */
Nint sciRx( unsigned char * pData, int len, int lenMin )
N{
N	int retVal;
N	int getNum;
N
N	retVal = 0;
N
N	for( ; len>0; ) {
N		/* get from buffer */
N		getNum = ringGet( &sciChan.rxRing, pData, len );
N		if( getNum < 0 ) {
N			return -1;
N		}
N
N		retVal += getNum;
N		pData  += getNum;
N		len    -= getNum;
N		lenMin -= getNum;
N
N		if( getNum == 0 ) {
N			if( lenMin <= 0 ) {
N				return retVal;
N			}
N		}
N	}
N
N	return retVal;
N}
N
N/*******************************************************************************
N *
N */
Nstatic void sciIntRx( unsigned int vecNo )
N{
N	SciChan * pChan;
N	SciReg  * pReg;
N
N	unsigned char rxBuff[RX_FIFO_NUM];
X	unsigned char rxBuff[4];
N	unsigned short ffrxVal;
N	int rxByte;
N	int i;
N
N//	pChan = (SciChan *)arg;
N	pChan = &sciChan;
N	pReg  = pChan->pReg;
N
N	ffrxVal = pReg->ffrx;
N	rxByte = FFRX_RXFFST( ffrxVal );
X	rxByte = (((ffrxVal)>>8)&0x01f);
N
N	for( ; rxByte; ) {
N		if( rxByte > RX_FIFO_NUM ) {
X		if( rxByte > 4 ) {
N			rxByte = RX_FIFO_NUM;
X			rxByte = 4;
N		}
N		for( i=0; i<rxByte; i++ ) {
N			rxBuff[i] = pReg->rxbuf;
N		}
N		ringSet( &pChan->rxRing, &rxBuff[0], rxByte );
N
N		ffrxVal = pReg->ffrx;
N		rxByte = FFRX_RXFFST( ffrxVal );
X		rxByte = (((ffrxVal)>>8)&0x01f);
N	}
N
N	pReg->ffrx |= FFRX_RXFFINT_CLR;
X	pReg->ffrx |= (1<<6);
N}
N
N
N/*** end of file : sciDrv.c ***/
