
#include "stdio.h"
#include "string.h"
#include "stdlib.h"

#include "config.h"
#include "sysLib.h"

#include "tms320f28035/tms320f28035.h"
#include "tms320f28035/timerDrv.h"

extern void InitSysCtrl(void);
extern void InitPieCtrl( void );

#define PIECTRL  (volatile unsigned short *)0x00000CE0 /* PIE, Control Register            */
#define PIEACK   (volatile unsigned short *)0x00000CE1 /* PIE, Acknowledge Register        */

#define PIEIER1  (volatile unsigned short *)0x00000CE2 /* PIE, INT1 Group Enable Register  */
#define PIEIFR1  (volatile unsigned short *)0x00000CE3 /* PIE, INT1 Group Flag Register    */

#define PIEIER2  (volatile unsigned short *)0x00000CE4 /* PIE, INT2 Group Enable Register  */
#define PIEIFR2  (volatile unsigned short *)0x00000CE5 /* PIE, INT2 Group Flag Register    */

#define PIEIER3  (volatile unsigned short *)0x00000CE6 /* PIE, INT3 Group Enable Register  */
#define PIEIFR3  (volatile unsigned short *)0x00000CE7 /* PIE, INT3 Group Flag Register    */

#define PIEIER4  (volatile unsigned short *)0x00000CE8 /* PIE, INT4 Group Enable Register  */
#define PIEIFR4  (volatile unsigned short *)0x00000CE9 /* PIE, INT4 Group Flag Register    */

#define PIEIER5  (volatile unsigned short *)0x00000CEA /* PIE, INT5 Group Enable Register  */
#define PIEIFR5  (volatile unsigned short *)0x00000CEB /* PIE, INT5 Group Flag Register    */

#define PIEIER6  (volatile unsigned short *)0x00000CEC /* PIE, INT6 Group Enable Register  */
#define PIEIFR6  (volatile unsigned short *)0x00000CED /* PIE, INT6 Group Flag Register    */

#define PIEIER7  (volatile unsigned short *)0x00000CEE /* PIE, INT7 Group Enable Register  */
#define PIEIFR7  (volatile unsigned short *)0x00000CEF /* PIE, INT7 Group Flag Register    */

#define PIEIER8  (volatile unsigned short *)0x00000CF0 /* PIE, INT8 Group Enable Register  */
#define PIEIFR8  (volatile unsigned short *)0x00000CF1 /* PIE, INT8 Group Flag Register    */

#define PIEIER9  (volatile unsigned short *)0x00000CF2 /* PIE, INT9 Group Enable Register  */
#define PIEIFR9  (volatile unsigned short *)0x00000CF3 /* PIE, INT9 Group Flag Register    */

#define PIEIER10 (volatile unsigned short *)0x00000CF4 /* PIE, INT10 Group Enable Register */
#define PIEIFR10 (volatile unsigned short *)0x00000CF5 /* PIE, INT10 Group Flag Register   */

#define PIEIER11 (volatile unsigned short *)0x00000CF6 /* PIE, INT11 Group Enable Register */
#define PIEIFR11 (volatile unsigned short *)0x00000CF7 /* PIE, INT11 Group Flag Register   */

#define PIEIER12 (volatile unsigned short *)0x00000CF8 /* PIE, INT12 Group Enable Register */
#define PIEIFR12 (volatile unsigned short *)0x00000CF9 /* PIE, INT12 Group Flag Register   */

#define	PIE_REG_END (volatile unsigned short *)0x00000CFA

static void intDummyFunc( unsigned int vecNo ){ sysIntDisable(vecNo); /* for(;;){;}*/ }

#define	_intFuncName( _id )	intFunc_##_id
#define	_IntFunc( _id ) interrupt void _intFuncName(_id)( ) { intFunc(_id); }

#if 1
extern "C" void _intFuncName(0)(void);
extern "C" void _intFuncName(1)(void);
extern "C" void _intFuncName(2)(void);
extern "C" void _intFuncName(3)(void);
extern "C" void _intFuncName(4)(void);
extern "C" void _intFuncName(5)(void);
extern "C" void _intFuncName(6)(void);
extern "C" void _intFuncName(7)(void);
extern "C" void _intFuncName(8)(void);
extern "C" void _intFuncName(9)(void);
extern "C" void _intFuncName(10)(void);
extern "C" void _intFuncName(11)(void);
extern "C" void _intFuncName(12)(void);
extern "C" void _intFuncName(13)(void);
extern "C" void _intFuncName(14)(void);
extern "C" void _intFuncName(15)(void);
extern "C" void _intFuncName(16)(void);
extern "C" void _intFuncName(17)(void);
extern "C" void _intFuncName(18)(void);
extern "C" void _intFuncName(19)(void);
extern "C" void _intFuncName(20)(void);
extern "C" void _intFuncName(21)(void);
extern "C" void _intFuncName(22)(void);
extern "C" void _intFuncName(23)(void);
extern "C" void _intFuncName(24)(void);
extern "C" void _intFuncName(25)(void);
extern "C" void _intFuncName(26)(void);
extern "C" void _intFuncName(27)(void);
extern "C" void _intFuncName(28)(void);
extern "C" void _intFuncName(29)(void);
extern "C" void _intFuncName(30)(void);
extern "C" void _intFuncName(31)(void);
extern "C" void _intFuncName(32)(void);
extern "C" void _intFuncName(33)(void);
extern "C" void _intFuncName(34)(void);
extern "C" void _intFuncName(35)(void);
extern "C" void _intFuncName(36)(void);
extern "C" void _intFuncName(37)(void);
extern "C" void _intFuncName(38)(void);
extern "C" void _intFuncName(39)(void);
extern "C" void _intFuncName(40)(void);
extern "C" void _intFuncName(41)(void);
extern "C" void _intFuncName(42)(void);
extern "C" void _intFuncName(43)(void);
extern "C" void _intFuncName(44)(void);
extern "C" void _intFuncName(45)(void);
extern "C" void _intFuncName(46)(void);
extern "C" void _intFuncName(47)(void);
extern "C" void _intFuncName(48)(void);
extern "C" void _intFuncName(49)(void);
extern "C" void _intFuncName(50)(void);
extern "C" void _intFuncName(51)(void);
extern "C" void _intFuncName(52)(void);
extern "C" void _intFuncName(53)(void);
extern "C" void _intFuncName(54)(void);
extern "C" void _intFuncName(55)(void);
extern "C" void _intFuncName(56)(void);
extern "C" void _intFuncName(57)(void);
extern "C" void _intFuncName(58)(void);
extern "C" void _intFuncName(59)(void);
extern "C" void _intFuncName(60)(void);
extern "C" void _intFuncName(61)(void);
extern "C" void _intFuncName(62)(void);
extern "C" void _intFuncName(63)(void);
extern "C" void _intFuncName(64)(void);
extern "C" void _intFuncName(65)(void);
extern "C" void _intFuncName(66)(void);
extern "C" void _intFuncName(67)(void);
extern "C" void _intFuncName(68)(void);
extern "C" void _intFuncName(69)(void);
extern "C" void _intFuncName(70)(void);
extern "C" void _intFuncName(71)(void);
extern "C" void _intFuncName(72)(void);
extern "C" void _intFuncName(73)(void);
extern "C" void _intFuncName(74)(void);
extern "C" void _intFuncName(75)(void);
extern "C" void _intFuncName(76)(void);
extern "C" void _intFuncName(77)(void);
extern "C" void _intFuncName(78)(void);
extern "C" void _intFuncName(79)(void);
extern "C" void _intFuncName(80)(void);
extern "C" void _intFuncName(81)(void);
extern "C" void _intFuncName(82)(void);
extern "C" void _intFuncName(83)(void);
extern "C" void _intFuncName(84)(void);
extern "C" void _intFuncName(85)(void);
extern "C" void _intFuncName(86)(void);
extern "C" void _intFuncName(87)(void);
extern "C" void _intFuncName(88)(void);
extern "C" void _intFuncName(89)(void);
extern "C" void _intFuncName(90)(void);
extern "C" void _intFuncName(91)(void);
extern "C" void _intFuncName(92)(void);
extern "C" void _intFuncName(93)(void);
extern "C" void _intFuncName(94)(void);
extern "C" void _intFuncName(95)(void);
extern "C" void _intFuncName(96)(void);
extern "C" void _intFuncName(97)(void);
extern "C" void _intFuncName(98)(void);
extern "C" void _intFuncName(99)(void);
extern "C" void _intFuncName(100)(void);
extern "C" void _intFuncName(101)(void);
extern "C" void _intFuncName(102)(void);
extern "C" void _intFuncName(103)(void);
extern "C" void _intFuncName(104)(void);
extern "C" void _intFuncName(105)(void);
extern "C" void _intFuncName(106)(void);
extern "C" void _intFuncName(107)(void);
extern "C" void _intFuncName(108)(void);
extern "C" void _intFuncName(109)(void);
extern "C" void _intFuncName(110)(void);
extern "C" void _intFuncName(111)(void);
extern "C" void _intFuncName(112)(void);
extern "C" void _intFuncName(113)(void);
extern "C" void _intFuncName(114)(void);
extern "C" void _intFuncName(115)(void);
extern "C" void _intFuncName(116)(void);
extern "C" void _intFuncName(117)(void);
extern "C" void _intFuncName(118)(void);
extern "C" void _intFuncName(119)(void);
extern "C" void _intFuncName(120)(void);
extern "C" void _intFuncName(121)(void);
extern "C" void _intFuncName(122)(void);
extern "C" void _intFuncName(123)(void);
extern "C" void _intFuncName(124)(void);
extern "C" void _intFuncName(125)(void);
extern "C" void _intFuncName(126)(void);
extern "C" void _intFuncName(127)(void);
#endif

static const unsigned long _intFuncInitTbl[] =
{
	(unsigned long)_intFuncName(0),
	(unsigned long)_intFuncName(1),
	(unsigned long)_intFuncName(2),
	(unsigned long)_intFuncName(3),
	(unsigned long)_intFuncName(4),
	(unsigned long)_intFuncName(5),
	(unsigned long)_intFuncName(6),
	(unsigned long)_intFuncName(7),
	(unsigned long)_intFuncName(8),
	(unsigned long)_intFuncName(9),
	(unsigned long)_intFuncName(10),
	(unsigned long)_intFuncName(11),
	(unsigned long)_intFuncName(12),
	(unsigned long)_intFuncName(13),
	(unsigned long)_intFuncName(14),
	(unsigned long)_intFuncName(15),
	(unsigned long)_intFuncName(16),
	(unsigned long)_intFuncName(17),
	(unsigned long)_intFuncName(18),
	(unsigned long)_intFuncName(19),
	(unsigned long)_intFuncName(20),
	(unsigned long)_intFuncName(21),
	(unsigned long)_intFuncName(22),
	(unsigned long)_intFuncName(23),
	(unsigned long)_intFuncName(24),
	(unsigned long)_intFuncName(25),
	(unsigned long)_intFuncName(26),
	(unsigned long)_intFuncName(27),
	(unsigned long)_intFuncName(28),
	(unsigned long)_intFuncName(29),
	(unsigned long)_intFuncName(30),
	(unsigned long)_intFuncName(31),
	(unsigned long)_intFuncName(32),
	(unsigned long)_intFuncName(33),
	(unsigned long)_intFuncName(34),
	(unsigned long)_intFuncName(35),
	(unsigned long)_intFuncName(36),
	(unsigned long)_intFuncName(37),
	(unsigned long)_intFuncName(38),
	(unsigned long)_intFuncName(39),
	(unsigned long)_intFuncName(40),
	(unsigned long)_intFuncName(41),
	(unsigned long)_intFuncName(42),
	(unsigned long)_intFuncName(43),
	(unsigned long)_intFuncName(44),
	(unsigned long)_intFuncName(45),
	(unsigned long)_intFuncName(46),
	(unsigned long)_intFuncName(47),
	(unsigned long)_intFuncName(48),
	(unsigned long)_intFuncName(49),
	(unsigned long)_intFuncName(50),
	(unsigned long)_intFuncName(51),
	(unsigned long)_intFuncName(52),
	(unsigned long)_intFuncName(53),
	(unsigned long)_intFuncName(54),
	(unsigned long)_intFuncName(55),
	(unsigned long)_intFuncName(56),
	(unsigned long)_intFuncName(57),
	(unsigned long)_intFuncName(58),
	(unsigned long)_intFuncName(59),
	(unsigned long)_intFuncName(60),
	(unsigned long)_intFuncName(61),
	(unsigned long)_intFuncName(62),
	(unsigned long)_intFuncName(63),
	(unsigned long)_intFuncName(64),
	(unsigned long)_intFuncName(65),
	(unsigned long)_intFuncName(66),
	(unsigned long)_intFuncName(67),
	(unsigned long)_intFuncName(68),
	(unsigned long)_intFuncName(69),
	(unsigned long)_intFuncName(70),
	(unsigned long)_intFuncName(71),
	(unsigned long)_intFuncName(72),
	(unsigned long)_intFuncName(73),
	(unsigned long)_intFuncName(74),
	(unsigned long)_intFuncName(75),
	(unsigned long)_intFuncName(76),
	(unsigned long)_intFuncName(77),
	(unsigned long)_intFuncName(78),
	(unsigned long)_intFuncName(79),
	(unsigned long)_intFuncName(80),
	(unsigned long)_intFuncName(81),
	(unsigned long)_intFuncName(82),
	(unsigned long)_intFuncName(83),
	(unsigned long)_intFuncName(84),
	(unsigned long)_intFuncName(85),
	(unsigned long)_intFuncName(86),
	(unsigned long)_intFuncName(87),
	(unsigned long)_intFuncName(88),
	(unsigned long)_intFuncName(89),
	(unsigned long)_intFuncName(90),
	(unsigned long)_intFuncName(91),
	(unsigned long)_intFuncName(92),
	(unsigned long)_intFuncName(93),
	(unsigned long)_intFuncName(94),
	(unsigned long)_intFuncName(95),
	(unsigned long)_intFuncName(96),
	(unsigned long)_intFuncName(97),
	(unsigned long)_intFuncName(98),
	(unsigned long)_intFuncName(99),
	(unsigned long)_intFuncName(100),
	(unsigned long)_intFuncName(101),
	(unsigned long)_intFuncName(102),
	(unsigned long)_intFuncName(103),
	(unsigned long)_intFuncName(104),
	(unsigned long)_intFuncName(105),
	(unsigned long)_intFuncName(106),
	(unsigned long)_intFuncName(107),
	(unsigned long)_intFuncName(108),
	(unsigned long)_intFuncName(109),
	(unsigned long)_intFuncName(110),
	(unsigned long)_intFuncName(111),
	(unsigned long)_intFuncName(112),
	(unsigned long)_intFuncName(113),
	(unsigned long)_intFuncName(114),
	(unsigned long)_intFuncName(115),
	(unsigned long)_intFuncName(116),
	(unsigned long)_intFuncName(117),
	(unsigned long)_intFuncName(118),
	(unsigned long)_intFuncName(119),
	(unsigned long)_intFuncName(120),
	(unsigned long)_intFuncName(121),
	(unsigned long)_intFuncName(122),
	(unsigned long)_intFuncName(123),
	(unsigned long)_intFuncName(124),
	(unsigned long)_intFuncName(125),
	(unsigned long)_intFuncName(126),
	(unsigned long)_intFuncName(127),
};
static unsigned long vVec[128];


#ifdef	SUPPORT_INT_0
#endif	/* SUPPORT_INT_0 */

extern unsigned int ramfuncs_loadstart;
extern unsigned int ramfuncs_loadsize;
extern unsigned int ramfuncs_runstart;


/*** for timer service ***/
#define	TIMER_CH	0
typedef struct sysTimer_t {
	int count;
	void (*pFunc)(void *);
	void * arg;
} SysTimer;

void sysTimerIsr( void * );
static int sysTimerInit( void );

static SysTimer		sysTimerTbl[SYS_TIMER_NUM];


/*******************************************************************************
 *
 */
int sysInit( void )
{
	/*
	 * Step 0. 'ramfunc' section initialize
	 */
	if( ramfuncs_runstart != ramfuncs_loadstart ) {
		memcpy( (void *)& ramfuncs_runstart,
		        (void *)& ramfuncs_loadstart,
		        (int)ramfuncs_loadsize );
	}

	/*
	 * Step 1. Initialize System Control:
	 */
	InitSysCtrl();		/* PLL, WatchDog, enable Peripheral Clocks
						 * This example function is found in the DSP2803x_SysCtrl.c file.
						 */

	/*
	 * Step 2. Initalize GPIO:
	 */
/*	 InitGpio();		?*
						 * This example function is found in the DSP2803x_Gpio.c file and
						 * illustrates how to set the GPIO to it's default state.
						 */

	/*
	 * Step 3. Clear all interrupts and initialize PIE vector table:
	 */
	DINT;				/* Disable CPU interrupts */

//	InitPieCtrl();		/* Initialize the PIE control registers to their default state.
//						 * The default state is all PIE interrupts disabled and flags
//						 * are cleared.
//						 * This function is found in the DSP2803x_PieCtrl.c file.
//						 */
	// Disable the PIE
//	PieCtrlRegs.PIECTRL.bit.ENPIE = 0;
	*PIECTRL &= ~1;

//	// Clear all PIEIER registers:
//	PieCtrlRegs.PIEIER1.all = 0;
//	PieCtrlRegs.PIEIER2.all = 0;
//	PieCtrlRegs.PIEIER3.all = 0;
//	PieCtrlRegs.PIEIER4.all = 0;
//	PieCtrlRegs.PIEIER5.all = 0;
//	PieCtrlRegs.PIEIER6.all = 0;
//	PieCtrlRegs.PIEIER7.all = 0;
//	PieCtrlRegs.PIEIER8.all = 0;
//	PieCtrlRegs.PIEIER9.all = 0;
//	PieCtrlRegs.PIEIER10.all = 0;
//	PieCtrlRegs.PIEIER11.all = 0;
//	PieCtrlRegs.PIEIER12.all = 0;
//
//	// Clear all PIEIFR registers:
//	PieCtrlRegs.PIEIFR1.all = 0;
//	PieCtrlRegs.PIEIFR2.all = 0;
//	PieCtrlRegs.PIEIFR3.all = 0;
//	PieCtrlRegs.PIEIFR4.all = 0;
//	PieCtrlRegs.PIEIFR5.all = 0;
//	PieCtrlRegs.PIEIFR6.all = 0;
//	PieCtrlRegs.PIEIFR7.all = 0;
//	PieCtrlRegs.PIEIFR8.all = 0;
//	PieCtrlRegs.PIEIFR9.all = 0;
//	PieCtrlRegs.PIEIFR10.all = 0;
//	PieCtrlRegs.PIEIFR11.all = 0;
//	PieCtrlRegs.PIEIFR12.all = 0;
	{
		volatile unsigned short * pReg;

		for( pReg=PIEIER1; pReg!=PIE_REG_END; pReg++ ) {
			*pReg = 0;
		}
	}

	IER = 0x0000;		/* Disable CPU interrupts */
	IFR = 0x0000;		/* and clear all CPU interrupt flags: */

//	InitPieVectTable();	/* Initialize the PIE vector table with pointers to the shell Interrupt
//						 * Service Routines (ISR).
//						 * This will populate the entire table, even if the interrupt
//						 * is not used in this example.  This is useful for debug purposes.
//						 * The shell ISR routines are found in DSP2803x_DefaultIsr.c.
//						 * This function is found in DSP2803x_PieVect.c.
//						 */
	{
		int vecNo;
		unsigned long * p = (unsigned long *)PIE_VECT_ADRS;

		/* Do not write over first 3 32-bit locations (these locations are
		 * initialized by Boot ROM with boot variables)
		 */
		p += 3;
		vecNo = 3;

		EALLOW;
		for( ; vecNo<128; vecNo++, p++ ) {
			*p = (unsigned long)_intFuncInitTbl[vecNo];
			vVec[vecNo] = (unsigned long)intDummyFunc;
		}
		EDIS;

//		PieCtrlRegs.PIECTRL.bit.ENPIE = 1;
		*PIECTRL |= 1;
	}

// Enable global Interrupts and higher priority real-time debug events:
	EINT;   // Enable Global interrupt INTM
	ERTM;   // Enable Global realtime interrupt DBGM

	return sysTimerInit();

}

/*******************************************************************************
 *
 */
//int sysIntLock(void);
//     move to sysLibasm.asm
// {
// }
//

/*******************************************************************************
 *
 */
void sysIntUnlock( int mask )
{
	if( ! mask ) {
		EINT;
	}
}

/*******************************************************************************
 *
 */
int sysIntConnect( unsigned int vecNo, void (*pFunc)(unsigned int) )
{
	int retVal = -1;
	int	intLockVal;

	if( vecNo < 128 ) {

		intLockVal = sysIntLock();

		vVec[vecNo] = (unsigned long)pFunc;

		sysIntUnlock( intLockVal );

		retVal = 0;
	}

	return retVal;
}

/*******************************************************************************
 *
 */
int sysIntDisconnect( unsigned int vecNo )
{
	int retVal = -1;
	int intLockVal;

	if( vecNo < 128 ) {
		sysIntDisable( vecNo );
		intLockVal = sysIntLock();
		vVec[vecNo] = (unsigned long)intDummyFunc;
		sysIntUnlock( intLockVal );

		retVal = 0;
	}

	return retVal;
}

/*******************************************************************************
 *
 */
int sysIntEnable( unsigned int vecNo )
{
	int retVal = -1;
	int intLockVal;
	int regNo;
	int	bit;
	volatile unsigned short * pPieieReg;

	if( vecNo < 32 ) {

		/* nothing todo. but not error */
		retVal = 0;

	} else if( vecNo < 128 ) {

		regNo = vecNo - 32;
		bit = regNo & 0x07;
		regNo /= 8;
		regNo *= 2;

		pPieieReg = PIEIER1;
		pPieieReg += regNo;

		intLockVal = sysIntLock();
		*pPieieReg |= (1<<bit);
		IER |= (1<<(regNo/2));
		sysIntUnlock( intLockVal );

		retVal = 0;
	} else {
		/* error : nothing todo */
	}

	return retVal;
}

/*******************************************************************************
 *
 */
int sysIntDisable( unsigned int vecNo )
{
	int retVal = -1;
	int intLockVal;

	int regNo;
	int bit;
	volatile unsigned short * pPieieReg;

	if( vecNo < 32 ) {
		/* nothing todo. but not error */
		retVal = 0;
	} else if( vecNo < 128 ) {
		regNo = vecNo - 32;
		bit = regNo & 0x07;
		regNo /= 8;
		regNo *= 2;

		pPieieReg = PIEIER1;
		pPieieReg += regNo;

		intLockVal = sysIntLock();
		*pPieieReg &= ~(1<<bit);
		if( *pPieieReg == 0 ) {
			IER &= ~(1<<(regNo/2));
		}
		sysIntUnlock( intLockVal );

		retVal = 0;
	} else {
		/* error : nothing todo */
	}

	return retVal;
}

/*******************************************************************************
 *
 */
extern "C" void intFunc( unsigned int vecNo )
{
	((void (*)(unsigned int))vVec[vecNo])( vecNo );

	if( vecNo < 32 ) {
		/* nothing todo */
	} else {
		vecNo -= 32;
		vecNo /= 8;
		*PIEACK = (1<<vecNo);
	}
}

/*******************************************************************************
 *
 */
void sysDummyFunc()
{
}

/*******************************************************************************
 *
 */
void sysHalt( const char * msg )
{
	for( ; ; ) {
		;
	}
}

/******************************************************************************/
/* System Timer                                                               */
/******************************************************************************/
/*******************************************************************************
 *
 */
static int sysTimerInit( void )
{
	int retVal = -1;
	int i;

	for( i=0; i<SYS_TIMER_NUM; i++ ) {
		sysTimerTbl[i].count = 0;
	}

	if( timerDrvInit() ) {
		goto abort;
	}

	if( timerConnect( TIMER_CH, sysTimerIsr, 0 ) ) {
		goto abort;
	}

	if( timerConfig( TIMER_CH, 1000 ) ) {
		goto abort;
	}

	if( timerRun( TIMER_CH ) ) {
		goto abort;
	}

	retVal = 0;
abort:
	return retVal;
}

/*******************************************************************************
 *
 */
int sysTimerConnect( int id, void (*pFunc)(void *), void * arg )
{
	int retVal = -1;
	int intLockVal;

	if( id <SYS_TIMER_NUM ) {

		intLockVal = sysIntLock();

		sysTimerTbl[id].pFunc = pFunc;
		sysTimerTbl[id].arg   = arg;

		sysIntUnlock( intLockVal );

		retVal = 0;
	}

	return retVal;
}

/*******************************************************************************
 *
 */
int sysTimerSet( int id, unsigned int mSec )
{
	int retVal = -1;
	int intLockVal;

	if( id < SYS_TIMER_NUM ) {

		intLockVal = sysIntLock();

		sysTimerTbl[id].count = mSec;

		sysIntUnlock( intLockVal );

		retVal = 0;
	}

	return retVal;
}


/*******************************************************************************
 *
 */
void sysTimerIsr( void * arg )
{
	int i;
	SysTimer * pTimer;

	for( i=0; i<SYS_TIMER_NUM; i++ ) {
		pTimer = &sysTimerTbl[i];
		if( pTimer->count ) {
			pTimer->count--;
			if( pTimer->count == 0 ) {
				pTimer->pFunc( pTimer->arg );
			}
		}
	}
}

