/*** sysLib.h - system i/f header ***/

/*** Copyright(C) 2008 mimu ***/

/*** NOTE ***
 */

/*** HISTORY ***
 * 2007/08/xx mimu@emb
              First version for SH-4A
 */

#ifndef	INC_sysLib_H
#define	INC_sysLib_H

#ifndef	_ASMLANGUAGE

#include	"config.h"

//#include	"kernel.h"

#ifdef	__cplusplus


int sysInit( void );

void sysDummyFunc();
extern "C" void sysHalt( const char * msg );

/* interrupt mask */
extern "C" int		sysIntLock( void );
void	sysIntUnlock( int );


/* for interrupt */
int sysIntConnect( unsigned int vecNo, void (*pFunc)(unsigned int vecNo) );
int sysIntDisconnect( unsigned int vecNo );
int sysIntEnable( unsigned int vecNo );
int sysIntDisable( unsigned int vecNo );

/* for timer service */
enum {
	SYSTIMER_PWM_0 = 0,
	SYSTIMER_PWM_1,
	SYSTIMER_PWM_2,
	SYSTIMER_PWM_3,
	SYSTIMER_PWM_4,
	SYSTIMER_PWM_5,
	SYSTIMER_PWM_6,

	SYS_TIMER_NUM
};

int sysTimerConnect( int id, void (*pFunc)(void *), void * arg );
int sysTimerSet( int id, unsigned int mSec );
#define	sysTimerClr( _id )	sysTimerSet( (_id), 0 )


#endif

#endif	/* _ASMLANGUAGE */
#endif	/* INC_sysLib_H */

/*** end of file : sysLib.h ***/
