/*** gpioDrv.h - TMS320F28035(piccolo) GPIO driver ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/02/09 mimu
              First Version
 */

#ifndef	INC_gpioDrv_H
#define	INC_gpioDrv_H

#ifdef	__cplusplus

#define	GPIO_MAX	44
#define	GPIO_NUM	45

int gpioInit( void );
int gpioConfig( int no, int mode );
#define	GPIO_MODE_GPIO			0x0001
#define	GPIO_MODE_1				0x0002
#define	GPIO_MODE_2				0x0004
#define	GPIO_MODE_3				0x0008

#define	GPIO_MODE_IN			0x0010
#define	GPIO_MODE_OUT			0x0020
#define	GPIO_MODE_PULLUP_DIS	0x0040
#define	GPIO_MODE_PULLUP		0x0080

#define	GPIO_MODE_QUALIFIER_0	0x0100
#define	GPIO_MODE_QUALIFIER_1	0x0200
#define	GPIO_MODE_QUALIFIER_2	0x0400
#define	GPIO_MODE_QUALIFIER_3	0x0800
#define	GPIO_MODE_QUALIFILER(_x)	(0x100<<(_x))&0x0f00))

#define	GPIO_MODE_XINT(_n)		((_n)<<12)
#define	GPIO_MODE_XINT1			GPIO_MODE_XINT(1)
#define	GPIO_MODE_XINT2			GPIO_MODE_XINT(2)
#define	GPIO_MODE_XINT3			GPIO_MODE_XINT(3)

#define	GPIO_MODE_XINTn_FALL	GPIO_MODE_XINT(4)
#define	GPIO_MODE_XINTn_RAISE	GPIO_MODE_XINT(8)
#define	GPIO_MODE_XINTn_BOTH	(GPIO_MODE_XINTn_FALL|GPIO_MODE_XINTn_RAISE)

#define	GPIO_CTRL_SET		0
#define	GPIO_CTRL_CLR		1
#define	GPIO_CTRL_TOGGLE	2
#define	GPIO_CTRL_GET		3
int gpioCtrl( int no, int ctrl );

#define	gpioControl( _no, _bH )	(bH?gpioCtrl(_no, GPIO_CTRL_SET):gpioCtrl(_no, GPIO_CTRL_CLR))
#define	gpioSet( _no )		gpioCtrl( _no, GPIO_CTRL_SET )
#define	gpioClear( _no )	gpioCtrl( _no, GPIO_CTRL_CLR )
#define	gpioToggle( _no )	gpioCtrl( _no, GPIO_CTRL_TOGGLE )
#define	gpioGet( _no )		gpioCtrl( _no, GPIO_CTRL_GET )

int gpioCtrlRegSet( int reg, int value );
#define	GPIO_CTRLREG_QUALPRD_0_7	0		/* GPIO 0-7 */
#define	GPIO_CTRLREG_QUALPRD_8_15	1		/* GPIO 8-15 */
#define	GPIO_CTRLREG_QUALPRD_16_23	2		/* GPIO 16-23 */
#define	GPIO_CTRLREG_QUALPRD_24_31	3		/* GPIO 24-31 */

#define	GPIO_CTRLREG_QUBLPRD_32_39	4		/* GPIO 32-39 */
#define	GPIO_CTRLREG_QUBLPRD_40_44	5		/* GPIO 32-44 */

#endif

#endif	/* INC_gpioDrv_H */

/*** end of file : gpioDrv.h ***/
