/*** f_analog.c - fpalette analog ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/03/06 mimu
              First Version
 */

/*** INCLUDE ***/
#include "f_analog.h"
#include "tms320f28035/pwmDrv.h"
#include "tms320f28035/adcDrv.h"

/*** DEFINE ***/
#define	BASE_CLK	100000	/* 100KHz */

/*** FUNCTION ***/

/*** WORK ***/

/*******************************************************************************
 *
 */
void analogWrite( uint8_t pinNo, int duty255 )
{
	int ch;
	int bSideB;


	if( (0<=pinNo) && (pinNo<=11) ) {
		ch = pinNo / 2;
		bSideB = pinNo & 1;
	} else if( pinNo ==40 ) {
		ch = 12;
		bSideB = 0;
	} else if( pinNo == 41 ) {
		ch = 13;
		bSideB = 1;
	} else {
		return;
	}

	pwm( ch, bSideB, BASE_CLK, ((float)duty255/255)*100, 0 );
}

/*******************************************************************************
 *
 */
int analogRead( uint8_t no )
{
	int retVal = -1;
	unsigned short data;

	if( no < 8 ) {
		if( adc( no, &data ) == 0 ) {
			retVal = (int)data;
		}
	}

	return retVal;
}

/*** end of file : f_analog.c ***/
