/*** f_gpio_pinMode.c - fpalette GPIO control : pinMode() ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/03/01 mimu
              First Version
 */

/*** NOTE ***/

/*** INCLUDE ***/

#include "f_gpio.h"

#include "tms320f28035/gpioDrv.h"

/*** DEFINE ***/

/*** FUNCTION ***/

/*** WORK ***/

/*******************************************************************************
 *
 */
void pinMode( uint8_t pin, uint8_t mode )
{
	int gpio_mode;

	gpio_mode = 0;
	switch( mode ) {
	case INPUT :
		gpio_mode = GPIO_MODE_GPIO | GPIO_MODE_IN | GPIO_MODE_PULLUP;
		break;
	case OUTPUT :
		gpio_mode = GPIO_MODE_GPIO | GPIO_MODE_OUT | GPIO_MODE_PULLUP;
		break;
	case MODE_2 :
		gpio_mode = GPIO_MODE_2;
		break;
	case MODE_3 :
		gpio_mode = GPIO_MODE_3;
		break;
	default :
		break;
	}

	if( gpio_mode ) {
		gpioConfig( pin, gpio_mode );
	}
}

/*** end of file : f_gpio_pinMode.c ***/
