/*** f_gpio_pulseIn.cpp ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/03/03 mimu
              First Version
 */

/*** INCLUDE ***/
#include "f_const.h"
#include "f_types.h"
#include "f_time.h"

#include "f_gpio.h"
/*** DEFINE ***/


/*** FUNCTION ***/

/*** WORK ***/
static const uint8_t sigTbl[4] = { LOW, HIGH, LOW, HIGH };

/*******************************************************************************
 *
 */
unsigned long pulseIn( uint8_t pin, uint8_t state, unsigned long uSec )
{
	unsigned long retVal;
	uint8_t * pSig;
	int st;
	fTime alarm;
	fTime measure;

	retVal = 0;

	if( state == HIGH ) {
		pSig = (uint8_t *)&sigTbl[0];
	} else {
		pSig = (uint8_t *)&sigTbl[1];
	}

	alarm.uSec = uSec;
	timeAlarmSet( & alarm );

	for( st=0; st<1; ) {
		if( digitalRead(pin) == *pSig ) {
			st++;
			pSig ++;
		} else {
			if( timeAlarmCheck( &alarm ) ) {
				goto done;
			}
		}
	}

	timeMeasureStart( & measure );
	for( ; ; ) {
		if( digitalRead( pin ) == *pSig ) {
			timeMeasureGet( &measure );
			retVal = measure.uSec;
			goto done;
		}
		if( timeAlarmCheck( &alarm ) ) {
			goto done;
		}
	}
	/* not reached */

done:
	return retVal;
}


/*** end of file : f_gpio_pulseIn.c ***/
