/*** f_gpio_shift.c - shiftIn/Out() ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/03/04 mimu
              First Version
 */

/*** INCLUDE ***/
#include "config.h"
#include "sysLib.h"

#include "tms320f28035/gpioDrv.h"

#include "f_types.h"
#include "f_const.h"

#include "f_gpio.h"

/*** DEFINE ***/

/*** FUNCTION ***/

/*** WORK ***/

/*******************************************************************************
 *
 */
void shiftOut( uint8_t dataNo, uint8_t clkNo, uint8_t order, uint8_t data )
{
	int bit;
	uint8_t bitMask;

	if( order == LSBFIRST ) {
		bitMask = 1;
	} else {
		bitMask = 0x80;
	}

	for( bit=0; bit<8; bit++ ) {
		if( data & bitMask ) {
			gpioSet( dataNo );
		} else {
			gpioClear( dataNo );
		}
		if( order == LSBFIRST ) {
			data >>= 1;
		} else {
			data <<= 1;
		}
		gpioSet( clkNo );
		gpioClear( clkNo );
	}

}

/*******************************************************************************
 *
 */
uint8_t shiftIn( uint8_t dataNo, uint8_t clkNo, uint8_t ordef )
{
	int data;
	int bit;
	int bitSet;

	data = 0;

	if( ordef == LSBFIRST ) {
		bitSet = 0x80;
	} else {
		bitSet = 1;
	}

	for( bit=0; bit<8; bit++ ) {
		if( ordef == LSBFIRST ) {
			data >>= 1;
		} else {
			data <<= 1;
		}
		gpioSet( clkNo );
		if( gpioGet( dataNo ) ) {
			data |= bitSet;
		}
		gpioClear( clkNo );
	}

	return (uint8_t)data;
}

