

#include "config.h"
#include "sysLib.h"
#include "tms320f28035/gpioDrv.h"
#include "tms320f28035/timerDrv.h"
#include "tms320f28035/pwmDrv.h"
#include "tms320f28035/adcDrv.h"

#include <WProgram.h>


static void mainError( int lineNo, int code )
{
	for( ; ; ) {
		;
	}
}

int main(void)
{
	int result;


	/*
	 * system initialize
	 */
//	init();
	result = sysInit();
	if( result ) { mainError( __LINE__, result ); }

	/*
	 * GPIO driver initialize
	 */
	result = gpioInit();
	if( result ) { mainError( __LINE__, result ); }

	/*
	 * Timer initialize
	 */
//	result = timerDrvInit( 60000000 );
//	if( result ) { mainError( __LINE__, result ); }

	result = f_time_init();
	if( result ) { mainError( __LINE__, result ); }

	result = pwm_init( );
	if( result ) { mainError (__LINE__, result ); }

	result = adc_init( 0 );
	if( result ) { mainError (__LINE__, result ); }


	setup();

	for( ; ; ) {
		loop();
	}

	return 0;
}

