/*** tone.cpp - fpalette tone control ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/08/24 mimu
              First Version
 */
#include "f_types.h"
#include "tms320f28035/pwmDrv.h"

static int pin2ch( int pin, int * ch, int * bSideB )
{
	if( pin < 11 ) {
		*bSideB = pin & 1;
		*ch = pin/2;
	} else if( pin == 40 ) {
		*bSideB = 0;
		*ch = 6;
	} else if( pin == 41 ) {
		*bSideB = 1;
		*ch = 6;
	} else {
		return -1;
	}

	return 0;
}

void tone( uint8_t pin, unsigned int freq, unsigned long duration )
{
	int ch;
	int bSideB;

	if( pin2ch( pin, &ch, &bSideB ) == 0 ) {
		pwm( ch, bSideB, freq, 50.0, duration );
	}

	return ;
}

void noTone( uint8_t pin )
{
	int ch;
	int bSideB;

	if( pin2ch( pin, &ch, &bSideB ) == 0 ) {
		pwm( ch, bSideB, 0, 0.0, 0 );
	}

	return ;
}

