/*******************************************************************************
 * pwm
 */
#include "WProgram.h"

#include "tms320f28035/pwmDrv.h"

static int pioSync;


static long freq;

#if 0
#define	FREQ_MIN	  1000
#define	FREQ_MAX	200000
#define	FREQ_STEP	  1000
#endif
#if 1
#define	FREQ_MIN	  1
#define	FREQ_MAX	10000
#define	FREQ_STEP	  100
#endif

static float duty;
#define	DUTY_MIN	-5.0
#define	DUTY_MAX	105.0
#define	DUTY_STEP	5.0

//#define	LIMIT		0
#define	LIMIT		160

void setup( void )
{

	pioSync = 0;
	pinMode(pioSync, OUTPUT);
	digitalWrite( pioSync, 0 );


	freq = FREQ_MIN;
	duty = DUTY_MIN;

	digitalWrite( pioSync, 1 );
	pwm( 0, 1, 100000, 50.0, 0 );
	pwm( 1, 1, 100000, duty, LIMIT );
	pwm( 2, 1, freq,   50.0, LIMIT );
	pwm( 3, 1, freq,   50.0, LIMIT );
	pwm( 4, 1, freq,   50.0, LIMIT );
	pwm( 5, 1, freq,   50.0, LIMIT );
	pwm( 6, 1, freq,   50.0, LIMIT );
	digitalWrite( pioSync, 0 );

}

void loop( void )
{
	delay( 1000 );
//	delay( 500 );

	duty += DUTY_STEP;
	if( duty > DUTY_MAX ) {
		duty = DUTY_MIN;
	}
	freq += FREQ_STEP;
	if( freq > FREQ_MAX ) {
		freq = FREQ_MIN;
	}

	digitalWrite( pioSync, 1 );
//	delay( 10 );
	pwm( 1, 1, 100000, duty, LIMIT );
	pwm( 2, 1, freq,   50.0, LIMIT/2 );
	pwm( 3, 1, freq,   50.0, LIMIT/4 );
	pwm( 4, 1, freq,   50.0, LIMIT/8 );
	pwm( 5, 1, freq,   50.0, LIMIT/16 );
	pwm( 6, 1, freq,   50.0, LIMIT/32 );
	digitalWrite( pioSync, 0 );
}

